'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

exports.default = login;

var _system = require('../utils/system');

var _system2 = _interopRequireDefault(_system);

var _loggingManager = require('logging-manager');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function login(req) {
  return new _promise2.default(function (resolve, reject) {
    var username = req.body.username;
    var password = req.body.password;

    setTimeout(function () {
      if (!_system2.default.checkForUser(username)) {
        reject({
          status: 401,
          errorField: 'username',
          errorReason: 'Username inccorect'
        });
      } else {
        _system2.default.checkUserPassword(username, password).then(function (matches) {
          if (matches) {
            var user = {
              username: username
            };
            req.session.user = user;
            resolve(user);
          } else {
            reject({
              status: 401,
              errorField: 'password',
              errorReason: 'Password inccorect'
            });
          }
        }, function (error) {
          _loggingManager.Instance.error('Login', 'login', 'Password comparison failed');
          _loggingManager.Instance.error('Login', 'login', error);
        });
      }
    }, 2000);
  });
}
module.exports = exports['default'];