'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

exports.default = devDelay;

var _loggingManager = require('logging-manager');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 *  This function is used in development to delay API responses in order to
 *  test loading panels. Using the __DEVELOPMENT__ keyword should remove this
 *  code completely in production.
 */
function devDelay(delay) {
  return new _promise2.default(function (resolve) {
    if (__DEVELOPMENT__) {
      _loggingManager.Instance.debug('System', 'devDelay', 'Using development API delay timer.');
      setTimeout(resolve, delay);
    } else {
      resolve();
    }
  });
}
module.exports = exports['default'];