'use strict';

require('babel-polyfill');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _createBrowserHistory = require('history/lib/createBrowserHistory');

var _createBrowserHistory2 = _interopRequireDefault(_createBrowserHistory);

var _useStandardScroll = require('scroll-behavior/lib/useStandardScroll');

var _useStandardScroll2 = _interopRequireDefault(_useStandardScroll);

var _create = require('./redux/create');

var _create2 = _interopRequireDefault(_create);

var _ApiClient = require('./helpers/ApiClient');

var _ApiClient2 = _interopRequireDefault(_ApiClient);

var _socket = require('socket.io-client');

var _socket2 = _interopRequireDefault(_socket);

var _reactRedux = require('react-redux');

var _reduxRouter = require('redux-router');

var _routes = require('./routes');

var _routes2 = _interopRequireDefault(_routes);

var _makeRouteHooksSafe = require('./helpers/makeRouteHooksSafe');

var _makeRouteHooksSafe2 = _interopRequireDefault(_makeRouteHooksSafe);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * THIS IS THE ENTRY POINT FOR THE CLIENT, JUST LIKE server.js IS THE ENTRY POINT FOR THE SERVER.
 */

var client = new _ApiClient2.default();

// Three different types of scroll behavior available.
// Documented here: https://github.com/rackt/scroll-behavior
var scrollableHistory = (0, _useStandardScroll2.default)(_createBrowserHistory2.default);

var dest = document.getElementById('content');
var store = (0, _create2.default)(_reduxRouter.reduxReactRouter, (0, _makeRouteHooksSafe2.default)(_routes2.default), scrollableHistory, client, window.__data);

function initSocket() {
  var socket = (0, _socket2.default)('', { path: '/ws' });
  socket.on('msg', function (data) {
    console.log(data);
  });

  return socket;
}

global.socket = initSocket();

var component = _react2.default.createElement(_reduxRouter.ReduxRouter, { routes: (0, _routes2.default)(store) });

_reactDom2.default.render(_react2.default.createElement(
  _reactRedux.Provider,
  { store: store, key: 'provider' },
  component
), dest);

if (process.env.NODE_ENV !== 'production') {
  window.React = _react2.default; // enable debugger

  if (!dest || !dest.firstChild || !dest.firstChild.attributes || !dest.firstChild.attributes['data-react-checksum']) {
    console.error('Server-side React render was discarded. Make sure that your initial render does not contain any client-side code.');
  }
}

if (__DEVTOOLS__ && !window.devToolsExtension) {
  var DevTools = require('./containers/DevTools/DevTools');
  _reactDom2.default.render(_react2.default.createElement(
    _reactRedux.Provider,
    { store: store, key: 'provider' },
    _react2.default.createElement(
      'div',
      null,
      component,
      _react2.default.createElement(DevTools, null)
    )
  ), dest);
}