'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp2;

var _components2 = require('../../components');

var _ActiveGroupPage = require('./ActiveGroupPage.scss');

var _ActiveGroupPage2 = _interopRequireDefault(_ActiveGroupPage);

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  ActiveGroupPage: {
    displayName: 'ActiveGroupPage'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/ActiveGroupPage/ActiveGroupPage.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var ActiveGroupPage = _wrapComponent('ActiveGroupPage')((_temp2 = _class = function (_Component) {
  (0, _inherits3.default)(ActiveGroupPage, _Component);

  function ActiveGroupPage() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ActiveGroupPage);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_Object$getPrototypeO = (0, _getPrototypeOf2.default)(ActiveGroupPage)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.setActiveGroupListFilter = function (event) {
      var setActiveGroupListFilter = _this.props.setActiveGroupListFilter;

      setActiveGroupListFilter(event.target.value);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ActiveGroupPage, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('ActiveGroupPage:cDU');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var activeGroupListFilter = _props.activeGroupListFilter;
      var groups = _props.groups;
      var logs = _props.logs;

      var activeLogs = [];
      if (groups) {
        (0, _keys2.default)(groups).forEach(function (groupId) {
          var group = groups[groupId];
          group.logs.forEach(function (logId) {
            var log = logs[logId];
            if (log.activeState !== 'INACTIVE') {
              activeLogs.push({
                logId: logId,
                groupId: groupId,
                logName: log.name,
                logFileName: log.fname,
                logFilePath: log.fpath,
                logStatus: log.activeState,
                logHasNew: log.hasNew
              });
            }
          });
        });
      }

      activeLogs.sort(function (first, second) {
        return first.logName.localeCompare(second.logName);
      });

      var groupList = {
        listFilter: activeGroupListFilter,
        logs: activeLogs
      };

      return _react3.default.createElement(
        'section',
        { className: _ActiveGroupPage2.default.activeGroupPage },
        _react3.default.createElement(_reactHelmet2.default, { title: 'Active Logs' }),
        _react3.default.createElement(
          'header',
          null,
          _react3.default.createElement(
            'h2',
            null,
            'Active Logs'
          ),
          _react3.default.createElement(
            'div',
            null,
            _react3.default.createElement('input', { ref: 'filter', type: 'text', placeholder: 'Filter list...', value: activeGroupListFilter, onChange: this.setActiveGroupListFilter }),
            _react3.default.createElement(_components2.Icon, { iconName: 'magnify' })
          )
        ),
        _react3.default.createElement(
          'section',
          null,
          _react3.default.createElement(_components2.LogGroupList, groupList)
        )
      );
    }
  }]);
  return ActiveGroupPage;
}(_react2.Component), _class.propTypes = {
  activeGroupListFilter: _react2.PropTypes.string,
  groups: _react2.PropTypes.object.isRequired,
  logs: _react2.PropTypes.object.isRequired,
  setActiveGroupListFilter: _react2.PropTypes.func
}, _temp2));

exports.default = ActiveGroupPage;
module.exports = exports['default'];