'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _dec, _class, _class2, _temp2;

var _AppManagementPage = require('./AppManagementPage.scss');

var _AppManagementPage2 = _interopRequireDefault(_AppManagementPage);

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

var _reactRedux = require('react-redux');

var _components2 = require('../../components');

var _appManagement = require('../../redux/modules/appManagement');

var _config = require('../../config');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  AppManagementPage: {
    displayName: 'AppManagementPage'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/AppManagementPage/AppManagementPage.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var logLevelOptions = [{
  text: 'SYSTEM',
  value: 'SYSTEM'
}, {
  text: 'FATAL',
  value: 'FATAL'
}, {
  text: 'ERROR',
  value: 'ERROR'
}, {
  text: 'INFO',
  value: 'INFO'
}, {
  text: 'DEBUG',
  value: 'DEBUG'
}, {
  text: 'TRACE',
  value: 'TRACE'
}];

function portElementIsValid(inputElement) {
  return inputElement && (inputElement.matches || inputElement.matchesSelector || inputElement.msMatchesSelector || inputElement.mozMatchesSelector || inputElement.webkitMatchesSelector || inputElement.oMatchesSelector).call(inputElement, ':valid');
}

var AppManagementPage = _wrapComponent('AppManagementPage')((_dec = (0, _reactRedux.connect)(null, { editWebPort: _appManagement.editWebPort, editApiPort: _appManagement.editApiPort, editLogLevel: _appManagement.editLogLevel, resetChanges: _appManagement.resetChanges, saveChanges: _appManagement.saveChanges }), _dec(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(AppManagementPage, _Component);

  function AppManagementPage() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, AppManagementPage);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_Object$getPrototypeO = (0, _getPrototypeOf2.default)(AppManagementPage)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.editWebPort = function (event) {
      var newWebPort = event.target.value;
      _this.props.editWebPort(newWebPort);
    }, _this.editApiPort = function (event) {
      var newApiPort = event.target.value;
      _this.props.editApiPort(newApiPort);
    }, _this.editLogLevel = function (event) {
      var newLogLevel = event.target.value;
      _this.props.editLogLevel(newLogLevel);
    }, _this.resetChanges = function () {
      _this.props.resetChanges();
    }, _this.saveChanges = function () {
      var _this$props$system = _this.props.system;
      var editableWebPort = _this$props$system.editableWebPort;
      var editableApiPort = _this$props$system.editableApiPort;
      var editableLogLevel = _this$props$system.editableLogLevel;

      _this.props.saveChanges(editableWebPort, editableApiPort, editableLogLevel);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(AppManagementPage, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('AppManagementPage:cDU');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var system = _props.system;
      var saving = _props.saving;

      var valuesHaveChanged = system.webport !== system.editableWebPort || system.apiport !== system.editableApiPort || system.loglevel !== system.editableLogLevel;

      var portsAreValid = portElementIsValid(this.refs.webportInput) && portElementIsValid(this.refs.apiportInput);

      return _react3.default.createElement(
        'section',
        { className: _AppManagementPage2.default.appManagementPage },
        _react3.default.createElement(_reactHelmet2.default, { title: 'Settings - App' }),
        _react3.default.createElement(
          'header',
          null,
          _react3.default.createElement(
            'h2',
            null,
            'Application Settings'
          ),
          _react3.default.createElement(
            'div',
            { className: _AppManagementPage2.default.actions },
            saving ? _react3.default.createElement(
              'div',
              { className: _AppManagementPage2.default.savingIndicator },
              _react3.default.createElement(_components2.LoadingSpinner, { size: 24, strokeWidth: 1 }),
              _react3.default.createElement(
                'p',
                null,
                'Saving...'
              )
            ) : _react3.default.createElement(
              'div',
              null,
              _react3.default.createElement(_components2.ControlButton, { iconName: 'delete', text: 'Reset changes', color: 'negative', isDisabled: !valuesHaveChanged, onClick: this.resetChanges }),
              _react3.default.createElement(_components2.ControlButton, { iconName: 'content-save', text: 'Save changes', color: 'positive', isDisabled: !valuesHaveChanged || !portsAreValid, onClick: this.saveChanges })
            )
          )
        ),
        _react3.default.createElement(
          'section',
          null,
          _react3.default.createElement(
            'h3',
            null,
            'Server Ports'
          ),
          _react3.default.createElement(
            'article',
            { className: _AppManagementPage2.default.alert },
            _react3.default.createElement(_components2.Icon, { iconName: 'alert-circle' }),
            _react3.default.createElement(
              'p',
              null,
              'The application must be manually restarted to reflect port changes'
            )
          ),
          _react3.default.createElement(
            'ul',
            null,
            _react3.default.createElement(
              'li',
              null,
              _react3.default.createElement(
                'label',
                null,
                'Web Port'
              ),
              _react3.default.createElement('input', { ref: 'webportInput', type: 'number', min: '0', max: '65535', required: true, value: system.editableWebPort, onChange: this.editWebPort, disabled: saving })
            ),
            _react3.default.createElement(
              'li',
              null,
              _react3.default.createElement(
                'label',
                null,
                'API Port'
              ),
              _react3.default.createElement('input', { ref: 'apiportInput', type: 'number', min: '0', max: '65535', required: true, value: system.editableApiPort, onChange: this.editApiPort, disabled: saving })
            )
          ),
          _react3.default.createElement(
            'h3',
            null,
            'Additional Settings'
          ),
          _react3.default.createElement(
            'ul',
            null,
            _react3.default.createElement(
              'li',
              null,
              _react3.default.createElement(
                'label',
                null,
                'Log Level'
              ),
              _react3.default.createElement(
                'div',
                { className: _AppManagementPage2.default.dropDown },
                _react3.default.createElement(_components2.DropDown, { options: logLevelOptions, onChange: this.editLogLevel, initialValue: system.editableLogLevel, isDisabled: saving })
              )
            )
          ),
          _react3.default.createElement(
            'h3',
            null,
            'App Info'
          ),
          _react3.default.createElement(
            'ul',
            { className: _AppManagementPage2.default.infoList },
            _react3.default.createElement(
              'li',
              null,
              _react3.default.createElement(
                'label',
                null,
                'Version'
              ),
              _react3.default.createElement(
                'p',
                null,
                'v1.0.4'
              )
            ),
            _config.releaseStage > 0 ? _react3.default.createElement(
              'li',
              null,
              _react3.default.createElement(
                'label',
                null,
                'Users Enabled'
              ),
              _react3.default.createElement(
                'p',
                null,
                'No'
              )
            ) : null,
            _react3.default.createElement(
              'li',
              null,
              _react3.default.createElement(
                'label',
                null,
                'Config File'
              ),
              _react3.default.createElement(
                'p',
                null,
                '/some/place/or/whatever/config.json'
              )
            )
          ),
          _react3.default.createElement(
            'p',
            { className: _AppManagementPage2.default.helpMeParagraph },
            'This application is currently in a stage of base feature development. This means that many decisions are still to be made or finalised and everything is open to improvement.'
          ),
          _react3.default.createElement(
            'p',
            { className: _AppManagementPage2.default.helpMeParagraph },
            'As a one-man team with little scope for user testing, any feedback you have would be greatly appreciated. Feel free to raise an issue or PR on the ',
            _react3.default.createElement(
              'a',
              { href: 'https://github.com/logger-app/logger-app', target: '_blank' },
              'GitHub repo'
            ),
            '.'
          )
        )
      );
    }
  }]);
  return AppManagementPage;
}(_react2.Component), _class2.propTypes = {
  system: _react2.PropTypes.object.isRequired,
  saving: _react2.PropTypes.bool,
  editWebPort: _react2.PropTypes.func.isRequired,
  editApiPort: _react2.PropTypes.func.isRequired,
  editLogLevel: _react2.PropTypes.func.isRequired,
  resetChanges: _react2.PropTypes.func.isRequired,
  saveChanges: _react2.PropTypes.func.isRequired
}, _temp2)) || _class));

exports.default = AppManagementPage;
module.exports = exports['default'];