'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp2;

var _components2 = require('../../components');

var _DashboardPage = require('./DashboardPage.scss');

var _DashboardPage2 = _interopRequireDefault(_DashboardPage);

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  DashboardPage: {
    displayName: 'DashboardPage'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/DashboardPage/DashboardPage.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var DashboardPage = _wrapComponent('DashboardPage')((_temp2 = _class = function (_Component) {
  (0, _inherits3.default)(DashboardPage, _Component);

  function DashboardPage() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, DashboardPage);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_Object$getPrototypeO = (0, _getPrototypeOf2.default)(DashboardPage)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.setDashboardListFilter = function (event) {
      var setDashboardListFilter = _this.props.setDashboardListFilter;

      setDashboardListFilter(event.target.value);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(DashboardPage, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('DashboardPage:cDU');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var dashboardListFilter = _props.dashboardListFilter;
      var groups = _props.groups;
      var logs = _props.logs;

      var activeLogs = [];
      var groupLists = [];

      (0, _keys2.default)(groups).forEach(function (groupId) {
        var group = groups[groupId];
        var groupLogs = [];

        group.logs.forEach(function (logId) {
          var log = logs[logId];

          // Add log to group list
          groupLogs.push({
            logId: logId,
            groupId: groupId,
            logName: log.name,
            logFileName: log.fname,
            logFilePath: log.fpath,
            logStatus: log.activeState,
            logHasNew: log.hasNew
          });

          // Add log to active list if isn't inactive
          if (log.activeState !== 'INACTIVE') {
            activeLogs.push({
              logId: logId,
              groupId: groupId,
              logName: log.name,
              logFileName: log.fname,
              logFilePath: log.fpath,
              logStatus: log.activeState,
              logHasNew: log.hasNew
            });
          }
        });

        groupLogs.sort(function (first, second) {
          return first.logName.localeCompare(second.logName);
        });

        groupLists.push({
          groupId: groupId,
          logs: groupLogs,
          listFilter: dashboardListFilter,
          groupName: group.name
        });
      });

      // Sort groups based on name
      groupLists.sort(function (first, second) {
        return first.groupName.localeCompare(second.groupName);
      });

      // Sort active logs and push to start of list
      activeLogs.sort(function (first, second) {
        return first.logName.localeCompare(second.logName);
      });
      groupLists.unshift({
        groupId: '-1',
        groupName: 'Active Group',
        listFilter: dashboardListFilter,
        logs: activeLogs
      });

      return _react3.default.createElement(
        'section',
        { className: _DashboardPage2.default.dashboardPage },
        _react3.default.createElement(_reactHelmet2.default, { title: 'Dashboard' }),
        _react3.default.createElement(
          'header',
          null,
          _react3.default.createElement(
            'h2',
            null,
            'Dashboard'
          ),
          _react3.default.createElement(
            'div',
            null,
            _react3.default.createElement('input', { ref: 'filter', type: 'text', placeholder: 'Filter list...', value: dashboardListFilter, onChange: this.setDashboardListFilter }),
            _react3.default.createElement(_components2.Icon, { iconName: 'magnify' })
          )
        ),
        _react3.default.createElement(
          'section',
          null,
          groupLists.map(function (groupList) {
            return _react3.default.createElement(
              'article',
              { key: groupList.groupId },
              _react3.default.createElement(
                'h3',
                null,
                groupList.groupName
              ),
              _react3.default.createElement(_components2.LogGroupList, groupList)
            );
          })
        )
      );
    }
  }]);
  return DashboardPage;
}(_react2.Component), _class.propTypes = {
  dashboardListFilter: _react2.PropTypes.string.isRequired,
  setDashboardListFilter: _react2.PropTypes.func.isRequired,
  groups: _react2.PropTypes.object.isRequired,
  logs: _react2.PropTypes.object.isRequired
}, _temp2));

exports.default = DashboardPage;
module.exports = exports['default'];