'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp;

var _GroupManagementPage = require('./GroupManagementPage.scss');

var _GroupManagementPage2 = _interopRequireDefault(_GroupManagementPage);

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

var _classnames9 = require('classnames');

var _classnames10 = _interopRequireDefault(_classnames9);

var _components2 = require('../../components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  GroupManagementPage: {
    displayName: 'GroupManagementPage'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/GroupManagementPage/GroupManagementPage.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var GroupManagementPage = _wrapComponent('GroupManagementPage')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(GroupManagementPage, _Component);

  function GroupManagementPage() {
    (0, _classCallCheck3.default)(this, GroupManagementPage);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(GroupManagementPage).apply(this, arguments));
  }

  (0, _createClass3.default)(GroupManagementPage, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      var shouldUpdate = false;
      /*  GroupManagementPage should only update if it is being passed a groups
       *  array which has changed any of the actual data rendered, i.e. group
       *  name, id (for link), amount of logs...
       */
      var currGroups = this.props.groups;
      var newGroups = nextProps.groups;

      // Check if any groups have been added or removed
      if ((0, _keys2.default)(currGroups).length !== (0, _keys2.default)(newGroups).length) {
        shouldUpdate = true;
      }

      var currGroupControls = this.props.newGroupControls;
      var nextGroupControls = nextProps.newGroupControls;
      if (currGroupControls.inputingNewGroup !== nextGroupControls.inputingNewGroup || currGroupControls.newGroupName !== nextGroupControls.newGroupName || currGroupControls.savingNewGroup !== nextGroupControls.savingNewGroup) {
        shouldUpdate = true;
      }

      // Check if any groups names have been changed
      (0, _keys2.default)(newGroups).forEach(function (newGroupId) {
        var newGroup = newGroups[newGroupId];
        if (!currGroups[newGroupId] || newGroup.name !== currGroups[newGroupId].name || newGroup.editNameOpen !== currGroups[newGroupId].editNameOpen || newGroup.editedName !== currGroups[newGroupId].editedName || newGroup.editedNameHasError !== currGroups[newGroupId].editedNameHasError || newGroup.editSaving !== currGroups[newGroupId].editSaving || newGroup.deleteGroupOpen !== currGroups[newGroupId].deleteGroupOpen || newGroup.deleteSaving !== currGroups[newGroupId].deleteSaving) {
          shouldUpdate = true;
        }
      });

      return shouldUpdate;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('GroupManagementPage:cDU');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var groups = _props.groups;
      var newGroupControls = _props.newGroupControls;
      var toggleEditNameOpen = _props.toggleEditNameOpen;
      var toggleDeleteGroupOpen = _props.toggleDeleteGroupOpen;
      var setEditedName = _props.setEditedName;
      var saveGroupName = _props.saveGroupName;
      var deleteGroup = _props.deleteGroup;
      var setNewGroupName = _props.setNewGroupName;
      var toggleInputingNewGroup = _props.toggleInputingNewGroup;
      var createNewGroup = _props.createNewGroup;

      var groupIdsAlphabetically = (0, _keys2.default)(groups).map(function (groupId) {
        return { groupId: groupId, name: groups[groupId].name };
      }).sort(function (first, second) {
        return first.name.localeCompare(second.name);
      }).map(function (obj) {
        return obj.groupId;
      });

      return _react3.default.createElement(
        'section',
        { className: _GroupManagementPage2.default.groupManagementPage },
        _react3.default.createElement(_reactHelmet2.default, { title: 'Admin - Groups' }),
        _react3.default.createElement(
          'header',
          null,
          _react3.default.createElement(
            'h2',
            null,
            'Group Management'
          )
        ),
        _react3.default.createElement(
          'section',
          null,
          _react3.default.createElement(
            'ul',
            null,
            _react3.default.createElement(
              'li',
              { className: _GroupManagementPage2.default.newGroupItem },
              _react3.default.createElement(
                'button',
                { onClick: function onClick() {
                    return toggleInputingNewGroup();
                  } },
                _react3.default.createElement(_components2.Icon, { iconName: 'plus' }),
                _react3.default.createElement(
                  'p',
                  null,
                  'New Group'
                )
              ),
              _react3.default.createElement(
                'div',
                { className: (0, _classnames10.default)(_GroupManagementPage2.default.editNamePanel, _GroupManagementPage2.default.fadeInPanel, (0, _defineProperty3.default)({}, _GroupManagementPage2.default.open, newGroupControls.inputingNewGroup)) },
                _react3.default.createElement(
                  'div',
                  { className: _GroupManagementPage2.default.lhs },
                  _react3.default.createElement(
                    'form',
                    { onSubmit: function onSubmit(event) {
                        createNewGroup(newGroupControls.newGroupName);event.preventDefault();return false;
                      } },
                    _react3.default.createElement('input', { type: 'text', placeholder: 'New group name', maxLength: '15', className: (0, _classnames10.default)((0, _defineProperty3.default)({}, _GroupManagementPage2.default.invalid, newGroupControls.errorSavingNewGroup)), value: newGroupControls.newGroupName, onChange: function onChange(event) {
                        return setNewGroupName(event.target.value);
                      } })
                  )
                ),
                _react3.default.createElement(
                  'div',
                  { className: _GroupManagementPage2.default.actions },
                  _react3.default.createElement(
                    'button',
                    { onClick: function onClick() {
                        return createNewGroup(newGroupControls.newGroupName);
                      } },
                    _react3.default.createElement(_components2.Icon, { iconName: 'check' })
                  ),
                  _react3.default.createElement(
                    'button',
                    { onClick: function onClick() {
                        return toggleInputingNewGroup();
                      } },
                    _react3.default.createElement(_components2.Icon, { iconName: 'close' })
                  )
                )
              ),
              _react3.default.createElement(
                'div',
                { className: (0, _classnames10.default)(_GroupManagementPage2.default.savingPanel, _GroupManagementPage2.default.fadeInPanel, (0, _defineProperty3.default)({}, _GroupManagementPage2.default.open, newGroupControls.savingNewGroup)) },
                _react3.default.createElement(_components2.LoadingSpinner, { size: 24, strokeWidth: 1 }),
                _react3.default.createElement(
                  'p',
                  null,
                  'Creating...'
                )
              )
            ),
            groupIdsAlphabetically.map(function (groupId) {
              return _react3.default.createElement(
                'li',
                { key: groupId, className: _GroupManagementPage2.default.groupItem },
                _react3.default.createElement(
                  'div',
                  { className: _GroupManagementPage2.default.basePanel },
                  _react3.default.createElement(
                    'div',
                    { className: _GroupManagementPage2.default.lhs },
                    _react3.default.createElement(
                      'p',
                      null,
                      groups[groupId].name
                    ),
                    _react3.default.createElement(
                      'p',
                      null,
                      groups[groupId].logs.length,
                      ' Log',
                      groups[groupId].logs.length !== 1 ? 's' : ''
                    )
                  ),
                  _react3.default.createElement(
                    'div',
                    { className: _GroupManagementPage2.default.actions },
                    _react3.default.createElement(
                      'button',
                      { onClick: function onClick() {
                          return toggleEditNameOpen(groupId);
                        } },
                      _react3.default.createElement(_components2.Icon, { iconName: 'pencil' })
                    ),
                    _react3.default.createElement(
                      'button',
                      { onClick: function onClick() {
                          return toggleDeleteGroupOpen(groupId);
                        } },
                      _react3.default.createElement(_components2.Icon, { iconName: 'delete' })
                    )
                  )
                ),
                _react3.default.createElement(
                  'div',
                  { className: (0, _classnames10.default)(_GroupManagementPage2.default.editNamePanel, _GroupManagementPage2.default.fadeInPanel, (0, _defineProperty3.default)({}, _GroupManagementPage2.default.open, groups[groupId].editNameOpen)) },
                  _react3.default.createElement(
                    'div',
                    { className: _GroupManagementPage2.default.lhs },
                    _react3.default.createElement(
                      'form',
                      { onSubmit: function onSubmit(event) {
                          saveGroupName(groupId, groups[groupId].editedName, groups[groupId].name);event.preventDefault();return false;
                        } },
                      _react3.default.createElement('input', { type: 'text', placeholder: 'Group name', maxLength: '15', className: (0, _classnames10.default)((0, _defineProperty3.default)({}, _GroupManagementPage2.default.invalid, groups[groupId].editedNameHasError)), value: groups[groupId].editedName, onChange: function onChange(event) {
                          return setEditedName(groupId, event.target.value);
                        } })
                    )
                  ),
                  _react3.default.createElement(
                    'div',
                    { className: _GroupManagementPage2.default.actions },
                    _react3.default.createElement(
                      'button',
                      { onClick: function onClick() {
                          return saveGroupName(groupId, groups[groupId].editedName, groups[groupId].name);
                        } },
                      _react3.default.createElement(_components2.Icon, { iconName: 'check' })
                    ),
                    _react3.default.createElement(
                      'button',
                      { onClick: function onClick() {
                          return toggleEditNameOpen(groupId);
                        } },
                      _react3.default.createElement(_components2.Icon, { iconName: 'close' })
                    )
                  )
                ),
                _react3.default.createElement(
                  'div',
                  { className: (0, _classnames10.default)(_GroupManagementPage2.default.savingPanel, _GroupManagementPage2.default.fadeInPanel, (0, _defineProperty3.default)({}, _GroupManagementPage2.default.open, groups[groupId].editSaving)) },
                  _react3.default.createElement(_components2.LoadingSpinner, { size: 24, strokeWidth: 1 }),
                  _react3.default.createElement(
                    'p',
                    null,
                    'Saving...'
                  )
                ),
                _react3.default.createElement(
                  'div',
                  { className: (0, _classnames10.default)(_GroupManagementPage2.default.deleteCheckPanel, _GroupManagementPage2.default.fadeInPanel, (0, _defineProperty3.default)({}, _GroupManagementPage2.default.open, groups[groupId].deleteGroupOpen)) },
                  _react3.default.createElement(
                    'div',
                    { className: _GroupManagementPage2.default.lhs },
                    _react3.default.createElement(
                      'p',
                      null,
                      'Are you sure you want to delete group: "',
                      groups[groupId].name,
                      '"'
                    ),
                    _react3.default.createElement(
                      'p',
                      null,
                      'Deleting a group will remove all of its logs!'
                    )
                  ),
                  _react3.default.createElement(
                    'div',
                    { className: _GroupManagementPage2.default.actions },
                    _react3.default.createElement(
                      'button',
                      { onClick: function onClick() {
                          return deleteGroup(groupId, groups[groupId].name);
                        } },
                      _react3.default.createElement(_components2.Icon, { iconName: 'check' })
                    ),
                    _react3.default.createElement(
                      'button',
                      { onClick: function onClick() {
                          return toggleDeleteGroupOpen(groupId);
                        } },
                      _react3.default.createElement(_components2.Icon, { iconName: 'close' })
                    )
                  )
                ),
                _react3.default.createElement(
                  'div',
                  { className: (0, _classnames10.default)(_GroupManagementPage2.default.deletingPanel, _GroupManagementPage2.default.fadeInPanel, (0, _defineProperty3.default)({}, _GroupManagementPage2.default.open, groups[groupId].deleteSaving)) },
                  _react3.default.createElement(_components2.LoadingSpinner, { size: 24, strokeWidth: 1 }),
                  _react3.default.createElement(
                    'p',
                    null,
                    'Deleting...'
                  )
                )
              );
            })
          )
        )
      );
    }
  }]);
  return GroupManagementPage;
}(_react2.Component), _class.propTypes = {
  groups: _react2.PropTypes.object.isRequired,
  newGroupControls: _react2.PropTypes.object.isRequired,
  toggleEditNameOpen: _react2.PropTypes.func.isRequired,
  toggleDeleteGroupOpen: _react2.PropTypes.func.isRequired,
  setEditedName: _react2.PropTypes.func.isRequired,
  saveGroupName: _react2.PropTypes.func.isRequired,
  deleteGroup: _react2.PropTypes.func.isRequired,
  setNewGroupName: _react2.PropTypes.func.isRequired,
  toggleInputingNewGroup: _react2.PropTypes.func.isRequired,
  createNewGroup: _react2.PropTypes.func.isRequired
}, _temp));

exports.default = GroupManagementPage;
module.exports = exports['default'];