'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _dec, _class, _class2, _temp2;

var _components2 = require('../../components');

var _GroupPage = require('./GroupPage.scss');

var _GroupPage2 = _interopRequireDefault(_GroupPage);

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

var _reactRedux = require('react-redux');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  GroupPage: {
    displayName: 'GroupPage'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/GroupPage/GroupPage.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var GroupPage = _wrapComponent('GroupPage')((_dec = (0, _reactRedux.connect)(function (state, props) {
  return {
    logs: props.group.logs.reduce(function (prev, curr) {
      return (0, _extends4.default)({}, prev, (0, _defineProperty3.default)({}, curr, state.logs.data[curr]));
    }, {})
  };
}), _dec(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(GroupPage, _Component);

  function GroupPage() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, GroupPage);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_Object$getPrototypeO = (0, _getPrototypeOf2.default)(GroupPage)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.setGroupListFilter = function (event) {
      var _this$props = _this.props;
      var groupId = _this$props.groupId;
      var setGroupListFilter = _this$props.setGroupListFilter;

      setGroupListFilter(groupId, event.target.value);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(GroupPage, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      /*  GroupPage should only update if it is being passed a new groupId
       *  or if the group list filter has changed. You can update the Logs
       *  or anything like that while viewing this page so no need to check
       *  them for any change.
       */
      var _props = this.props;
      var currId = _props.groupId;
      var currGroup = _props.group;
      var nextId = nextProps.groupId;
      var nextGroup = nextProps.group;

      return currId !== nextId || currGroup.listFilter !== nextGroup.listFilter;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('GroupPage:cDU');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props;
      var group = _props2.group;
      var logs = _props2.logs;

      var listLogs = group.logs.map(function (logId) {
        return {
          logId: logId,
          logName: logs[logId].name,
          logFileName: logs[logId].fname,
          logFilePath: logs[logId].fpath,
          logStatus: logs[logId].activeState,
          logHasNew: logs[logId].hasNew
        };
      });

      listLogs.sort(function (first, second) {
        return first.logName.localeCompare(second.logName);
      });

      var groupList = {
        listFilter: group.listFilter,
        logs: listLogs
      };

      return _react3.default.createElement(
        'section',
        { className: _GroupPage2.default.groupPage },
        _react3.default.createElement(_reactHelmet2.default, { title: group.name }),
        _react3.default.createElement(
          'header',
          null,
          _react3.default.createElement(
            'h2',
            null,
            group.name
          ),
          _react3.default.createElement(
            'div',
            null,
            _react3.default.createElement('input', { ref: 'filter', type: 'text', placeholder: 'Filter list...', value: group.listFilter, onChange: this.setGroupListFilter }),
            _react3.default.createElement(_components2.Icon, { iconName: 'magnify' })
          )
        ),
        _react3.default.createElement(
          'section',
          null,
          _react3.default.createElement(_components2.LogGroupList, groupList)
        )
      );
    }
  }]);
  return GroupPage;
}(_react2.Component), _class2.propTypes = {
  groupId: _react2.PropTypes.string.isRequired,
  group: _react2.PropTypes.object.isRequired,
  logs: _react2.PropTypes.object.isRequired,
  setGroupListFilter: _react2.PropTypes.func.isRequired
}, _temp2)) || _class));

exports.default = GroupPage;
module.exports = exports['default'];