'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp;

var _HighlightedText = require('./HighlightedText.scss');

var _HighlightedText2 = _interopRequireDefault(_HighlightedText);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  HighlightedText: {
    displayName: 'HighlightedText'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/HighlightedText/HighlightedText.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

function getIndicesOf(matchText, text) {
  var startIndex = 0;
  var newIndex = undefined;
  var indices = [];

  newIndex = text.toLowerCase().indexOf(matchText.toLowerCase(), startIndex);
  while (newIndex > -1) {
    indices.push(newIndex);
    startIndex = newIndex + matchText.length;
    newIndex = text.toLowerCase().indexOf(matchText.toLowerCase(), startIndex);
  }
  return indices;
}

var HighlightedText = _wrapComponent('HighlightedText')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(HighlightedText, _Component);

  function HighlightedText() {
    (0, _classCallCheck3.default)(this, HighlightedText);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(HighlightedText).apply(this, arguments));
  }

  (0, _createClass3.default)(HighlightedText, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      /*  Component should only update if text or matchText changes
       */
      return this.props.text !== nextProps.text || this.props.matchText !== nextProps.matchText;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('HighlightedText:cDU');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var text = _props.text;
      var matchText = _props.matchText;

      // Get indices of occurences

      var splits = undefined;
      if (!!matchText) {
        (function () {
          var indices = getIndicesOf(matchText, text);
          if (!!indices.length) {
            splits = [];
            splits.push(text.substring(0, indices[0]));
            indices.forEach(function (startOfMatch, index) {
              splits.push(text.substring(startOfMatch, startOfMatch + matchText.length));
              if (index === indices.length - 1) {
                // Is last matchedPosition
                splits.push(text.substring(startOfMatch + matchText.length, text.length));
              } else {
                // Isn't last so get up to the next one
                splits.push(text.substring(startOfMatch + matchText.length, indices[index + 1]));
              }
            });
          }
        })();
      }

      var output = undefined;
      if (!splits) {
        output = _react3.default.createElement(
          'span',
          null,
          text
        );
      } else {
        output = _react3.default.createElement(
          'span',
          null,
          splits.map(function (str, index) {
            return _react3.default.createElement(
              'span',
              { key: index, className: index % 2 ? _HighlightedText2.default.matchedText : null },
              str
            );
          })
        );
      }

      return output;
    }
  }]);
  return HighlightedText;
}(_react2.Component), _class.propTypes = {
  text: _react2.PropTypes.string.isRequired,
  matchText: _react2.PropTypes.string
}, _temp));

exports.default = HighlightedText;
module.exports = exports['default'];