'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp;

var _components2 = require('../../components');

var _LogGroupList = require('./LogGroupList.scss');

var _LogGroupList2 = _interopRequireDefault(_LogGroupList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  LogGroupList: {
    displayName: 'LogGroupList'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/LogGroupList/LogGroupList.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var LogGroupList = _wrapComponent('LogGroupList')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(LogGroupList, _Component);

  function LogGroupList() {
    (0, _classCallCheck3.default)(this, LogGroupList);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(LogGroupList).apply(this, arguments));
  }

  (0, _createClass3.default)(LogGroupList, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      /*  This component should only update if the IDs, name, activeState or
       *  isVisisble values change.
       *
       *  This is actually a lot more elegant than it may seem as if say the
       *  group name is the change, the later comparisons won't actually be made.
       */
      return this.props.listFilter !== nextProps.listFilter || this.props.logs.length !== nextProps.logs.length || this.props.logs.reduce(function (prevValue, currLog, index) {
        var nextLog = nextProps.logs[index];
        return prevValue || currLog.logId !== nextLog.logId || currLog.groupId !== nextLog.groupId || currLog.logName !== nextLog.logName || currLog.logFileName !== nextLog.logFileName || currLog.logFilePath !== nextLog.logFilePath || currLog.logStatus !== nextLog.logStatus || currLog.logHasNew !== nextLog.logHasNew;
      }, false);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('LogGroupList:cDU');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var listFilter = _props.listFilter;
      var logs = _props.logs;

      var allLogsFiltered = logs.length > 0;
      return _react3.default.createElement(
        'article',
        { className: _LogGroupList2.default.logGroupList },
        _react3.default.createElement(
          'ul',
          null,
          logs.length > 0 ? logs.map(function (log, index) {
            var output = null;
            if (!listFilter || log.logName.toLowerCase().indexOf(listFilter.toLowerCase()) > -1 || (log.logFilePath + log.logFileName).toLowerCase().indexOf(listFilter.toLowerCase()) > -1) {
              allLogsFiltered = false;
              output = _react3.default.createElement(_components2.LogGroupListItem, (0, _extends3.default)({ key: index }, log, { listFilter: listFilter }));
            }
            return output;
          }) : _react3.default.createElement(
            'li',
            { className: _LogGroupList2.default.noLogsLine },
            _react3.default.createElement(
              'p',
              null,
              'There are no logs in this group'
            )
          ),
          allLogsFiltered ? _react3.default.createElement(
            'li',
            { className: _LogGroupList2.default.noLogsLine },
            _react3.default.createElement(
              'p',
              null,
              'No logs matching the filter “',
              listFilter,
              '”'
            )
          ) : null
        )
      );
    }
  }]);
  return LogGroupList;
}(_react2.Component), _class.propTypes = {
  listFilter: _react2.PropTypes.string.isRequired,
  logs: _react2.PropTypes.array.isRequired
}, _temp));

exports.default = LogGroupList;
module.exports = exports['default'];