'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp;

var _reactRouter = require('react-router');

var _components2 = require('../../components');

var _LogGroupListItem = require('./LogGroupListItem.scss');

var _LogGroupListItem2 = _interopRequireDefault(_LogGroupListItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  LogGroupListItem: {
    displayName: 'LogGroupListItem'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/LogGroupListItem/LogGroupListItem.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var LogGroupListItem = _wrapComponent('LogGroupListItem')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(LogGroupListItem, _Component);

  function LogGroupListItem() {
    (0, _classCallCheck3.default)(this, LogGroupListItem);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(LogGroupListItem).apply(this, arguments));
  }

  (0, _createClass3.default)(LogGroupListItem, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      /*  Should only update if IDs, name, file name, file path, activeState,
       *  hasNew or listFilter change
       */
      return this.props.logId !== nextProps.logId || this.props.logName !== nextProps.logName || this.props.logFilePath !== nextProps.logFilePath || this.props.logFileName !== nextProps.logFileName || this.props.logHasNew !== nextProps.logHasNew || this.props.logStatus !== nextProps.logStatus || this.props.listFilter !== nextProps.listFilter;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('LogGroupListItem:cDU');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var logId = _props.logId;
      var logName = _props.logName;
      var logFilePath = _props.logFilePath;
      var logFileName = _props.logFileName;
      var logStatus = _props.logStatus;
      var logHasNew = _props.logHasNew;
      var listFilter = _props.listFilter;

      var colorClass = undefined;
      switch (logStatus) {
        case 'ACTIVE':
          colorClass = logHasNew ? _LogGroupListItem2.default.active : _LogGroupListItem2.default.idle;
          break;
        case 'PAUSED':
          colorClass = _LogGroupListItem2.default.paused;
          break;
        case 'INACTIVE_WITH_OUTPUT':
          colorClass = _LogGroupListItem2.default.hasOutput;
          break;
        default:
          colorClass = '';
          break;
      }
      return _react3.default.createElement(
        'li',
        { className: _LogGroupListItem2.default.logGroupListItem },
        _react3.default.createElement(
          _reactRouter.Link,
          { to: '/dashboard/log/' + logId },
          _react3.default.createElement('i', { className: colorClass }),
          _react3.default.createElement(
            'div',
            null,
            _react3.default.createElement(
              'p',
              null,
              listFilter ? _react3.default.createElement(_components2.HighlightedText, { text: logName, matchText: listFilter }) : _react3.default.createElement(
                'span',
                null,
                logName
              )
            ),
            _react3.default.createElement(
              'p',
              { title: logFilePath + logFileName },
              listFilter ? _react3.default.createElement(_components2.HighlightedText, { text: logFilePath + logFileName, matchText: listFilter }) : _react3.default.createElement(
                'span',
                null,
                logFilePath + logFileName
              )
            )
          )
        )
      );
    }
  }]);
  return LogGroupListItem;
}(_react2.Component), _class.propTypes = {
  logId: _react2.PropTypes.string.isRequired,
  logName: _react2.PropTypes.string.isRequired,
  logFileName: _react2.PropTypes.string.isRequired,
  logFilePath: _react2.PropTypes.string.isRequired,
  logStatus: _react2.PropTypes.string.isRequired,
  logHasNew: _react2.PropTypes.bool.isRequired,
  listFilter: _react2.PropTypes.string
}, _temp));

exports.default = LogGroupListItem;
module.exports = exports['default'];