'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp;

var _LogManagementPage = require('./LogManagementPage.scss');

var _LogManagementPage2 = _interopRequireDefault(_LogManagementPage);

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

var _classnames4 = require('classnames');

var _classnames5 = _interopRequireDefault(_classnames4);

var _components2 = require('../../components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  LogManagementPage: {
    displayName: 'LogManagementPage'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/LogManagementPage/LogManagementPage.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var LogManagementPage = _wrapComponent('LogManagementPage')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(LogManagementPage, _Component);

  function LogManagementPage() {
    (0, _classCallCheck3.default)(this, LogManagementPage);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(LogManagementPage).apply(this, arguments));
  }

  (0, _createClass3.default)(LogManagementPage, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('LogManagementPage:cDU');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var groups = _props.groups;
      var logs = _props.logs;
      var logManagementState = _props.logManagementState;
      var toggleSortByGroup = _props.toggleSortByGroup;
      var toggleInputingNewGroup = _props.toggleInputingNewGroup;
      var setNewLogName = _props.setNewLogName;
      var setNewLogGroup = _props.setNewLogGroup;
      var setNewLogFile = _props.setNewLogFile;
      var setNewLogPath = _props.setNewLogPath;
      var createNewLog = _props.createNewLog;

      var fullLogList = [];
      var groupIdsAlphabetically = undefined;

      var groupOptionsList = [{
        text: 'Select a group',
        value: '-1'
      }];

      (0, _keys2.default)(groups).forEach(function (groupId) {
        groupOptionsList.push({
          text: groups[groupId].name,
          value: '' + groupId
        });

        if (!logManagementState.sortByGroup) {
          groups[groupId].logs.forEach(function (logId) {
            var log = logs[logId];
            fullLogList.push((0, _extends3.default)({}, log, {
              logId: logId,
              groupId: groupId
            }));
          });
        } else {
          // Sort log IDs alphabetically by log name
          groups[groupId].logs = groups[groupId].logs.sort(function (first, second) {
            return logs[first].name.localeCompare(logs[second].name);
          });
        }
      });

      if (!logManagementState.sortByGroup) {
        fullLogList.sort(function (first, second) {
          return first.name.localeCompare(second.name);
        });
      } else {
        groupIdsAlphabetically = (0, _keys2.default)(groups).sort(function (first, second) {
          return groups[first].name.localeCompare(groups[second].name);
        });
      }

      return _react3.default.createElement(
        'section',
        { className: _LogManagementPage2.default.logManagementPage },
        _react3.default.createElement(_reactHelmet2.default, { title: 'Admin - Logs' }),
        _react3.default.createElement(
          'header',
          null,
          _react3.default.createElement(
            'h2',
            null,
            'Log Management'
          ),
          _react3.default.createElement(
            'div',
            { className: _LogManagementPage2.default.actions },
            _react3.default.createElement(
              'div',
              null,
              _react3.default.createElement(
                'label',
                { htmlFor: 'logManagementPageSortByGroup' },
                'Sort by group'
              ),
              _react3.default.createElement('input', { id: 'logManagementPageSortByGroup', type: 'checkbox', checked: logManagementState.sortByGroup, onChange: toggleSortByGroup })
            )
          )
        ),
        _react3.default.createElement(
          'section',
          null,
          _react3.default.createElement(
            'div',
            { className: (0, _classnames5.default)(_LogManagementPage2.default.newLogContainer, (0, _defineProperty3.default)({}, _LogManagementPage2.default.addLogOpen, logManagementState.inputingNewLog)) },
            _react3.default.createElement(
              'button',
              { className: _LogManagementPage2.default.addButton, onClick: function onClick() {
                  return toggleInputingNewGroup();
                } },
              _react3.default.createElement(_components2.Icon, { iconName: 'plus' }),
              _react3.default.createElement(
                'p',
                null,
                'New Log'
              )
            ),
            _react3.default.createElement(
              'div',
              { className: (0, _classnames5.default)(_LogManagementPage2.default.formContainer, _LogManagementPage2.default.fadeInPanel) },
              _react3.default.createElement(
                'div',
                { className: _LogManagementPage2.default.lhs },
                _react3.default.createElement(
                  'form',
                  { onSubmit: function onSubmit(event) {
                      createNewLog(logManagementState.newLogName, logManagementState.newLogGroup, logManagementState.newLogFile, logManagementState.newLogPath);event.preventDefault();return false;
                    } },
                  _react3.default.createElement('input', { type: 'text', placeholder: 'New log name', maxLength: '15', value: logManagementState.newLogName, onChange: function onChange(event) {
                      return setNewLogName(event.target.value);
                    } }),
                  _react3.default.createElement(_components2.DropDown, { customClassName: (0, _classnames5.default)(_LogManagementPage2.default.selectStyling, (0, _defineProperty3.default)({}, _LogManagementPage2.default.placeholderColour, logManagementState.newLogGroup === '-1')), options: groupOptionsList, initialValue: logManagementState.newLogGroup, onChange: function onChange(event) {
                      return setNewLogGroup(event.target.value);
                    } }),
                  _react3.default.createElement('input', { type: 'text', placeholder: 'File name', maxLength: '1000', value: logManagementState.newLogFile, onChange: function onChange(event) {
                      return setNewLogFile(event.target.value);
                    } }),
                  _react3.default.createElement('input', { type: 'text', placeholder: 'File location', maxLength: '1000', value: logManagementState.newLogPath, onChange: function onChange(event) {
                      return setNewLogPath(event.target.value);
                    } })
                )
              ),
              _react3.default.createElement(
                'div',
                { className: _LogManagementPage2.default.actions },
                _react3.default.createElement(
                  'button',
                  { onClick: function onClick() {
                      return createNewLog(logManagementState.newLogName, logManagementState.newLogGroup, logManagementState.newLogFile, logManagementState.newLogPath);
                    } },
                  _react3.default.createElement(_components2.Icon, { iconName: 'check' })
                ),
                _react3.default.createElement(
                  'button',
                  { onClick: function onClick() {
                      return toggleInputingNewGroup();
                    } },
                  _react3.default.createElement(_components2.Icon, { iconName: 'close' })
                )
              )
            ),
            _react3.default.createElement(
              'div',
              { className: (0, _classnames5.default)(_LogManagementPage2.default.savingPanel, _LogManagementPage2.default.fadeInPanel, (0, _defineProperty3.default)({}, _LogManagementPage2.default.open, logManagementState.savingNewLog)) },
              _react3.default.createElement(_components2.LoadingSpinner, { size: 24, strokeWidth: 1 }),
              _react3.default.createElement(
                'p',
                null,
                'Creating...'
              )
            )
          ),
          _react3.default.createElement(
            'div',
            { className: _LogManagementPage2.default.listContainer },
            logManagementState.sortByGroup ? groupIdsAlphabetically.map(function (groupId) {
              return _react3.default.createElement(
                'div',
                { key: groupId },
                _react3.default.createElement(
                  'h3',
                  null,
                  groups[groupId].name
                ),
                _react3.default.createElement(
                  'ol',
                  null,
                  groups[groupId].logs.length > 0 ? groups[groupId].logs.map(function (logId) {
                    return _react3.default.createElement(
                      'li',
                      { key: logId },
                      _react3.default.createElement(_components2.LogManagementPageLogPanel, { groupId: groupId, logId: logId, log: logs[logId], groupOptionsList: groupOptionsList })
                    );
                  }) : _react3.default.createElement(
                    'li',
                    { className: _LogManagementPage2.default.noLogsLine },
                    _react3.default.createElement(
                      'p',
                      null,
                      'There are no logs in this group'
                    )
                  )
                )
              );
            }) : _react3.default.createElement(
              'ol',
              { className: _LogManagementPage2.default.singleList },
              fullLogList.map(function (log) {
                return _react3.default.createElement(
                  'li',
                  { key: log.logId },
                  _react3.default.createElement(_components2.LogManagementPageLogPanel, { groupName: groups[log.groupId].name, groupId: log.groupId, logId: log.logId, log: log, groupOptionsList: groupOptionsList })
                );
              })
            )
          )
        )
      );
    }
  }]);
  return LogManagementPage;
}(_react2.Component), _class.propTypes = {
  groups: _react2.PropTypes.object.isRequired,
  logs: _react2.PropTypes.object.isRequired,
  logManagementState: _react2.PropTypes.object.isRequired,
  toggleSortByGroup: _react2.PropTypes.func.isRequired,
  toggleInputingNewGroup: _react2.PropTypes.func.isRequired,
  setNewLogName: _react2.PropTypes.func.isRequired,
  setNewLogGroup: _react2.PropTypes.func.isRequired,
  setNewLogFile: _react2.PropTypes.func.isRequired,
  setNewLogPath: _react2.PropTypes.func.isRequired,
  createNewLog: _react2.PropTypes.func.isRequired
}, _temp));

exports.default = LogManagementPage;
module.exports = exports['default'];