'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _dec, _class, _class2, _temp2;

var _LogPageHeader = require('./LogPageHeader.scss');

var _LogPageHeader2 = _interopRequireDefault(_LogPageHeader);

var _components2 = require('../../components');

var _reactRedux = require('react-redux');

var _logs = require('../../redux/modules/logs');

var _reactRouter = require('react-router');

var _config = require('../../config');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  LogPageHeader: {
    displayName: 'LogPageHeader'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/LogPageHeader/LogPageHeader.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var LogPageHeader = _wrapComponent('LogPageHeader')((_dec = (0, _reactRedux.connect)(null, { toggleLogExtraActionsOpen: _logs.toggleLogExtraActionsOpen, activateLog: _logs.activateLog, pauseLog: _logs.pauseLog, resumeLog: _logs.resumeLog, deactivateLog: _logs.deactivateLog, clearLogOutput: _logs.clearLogOutput, toggleScrollLock: _logs.toggleScrollLock }), _dec(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(LogPageHeader, _Component);

  function LogPageHeader() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, LogPageHeader);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_Object$getPrototypeO = (0, _getPrototypeOf2.default)(LogPageHeader)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.triggerActivateLog = function () {
      var _this$props = _this.props;
      var logId = _this$props.logId;
      var activateLog = _this$props.activateLog; // eslint-disable-line no-shadow

      activateLog(logId);
      socket.emit('attachLogListener', { logId: logId });
    }, _this.triggerDeactivateLog = function () {
      var _this$props2 = _this.props;
      var logId = _this$props2.logId;
      var deactivateLog = _this$props2.deactivateLog; // eslint-disable-line no-shadow

      deactivateLog(logId);
      socket.emit('detachLogListener', { logId: logId });
    }, _this.triggerPauseLog = function () {
      var _this$props3 = _this.props;
      var logId = _this$props3.logId;
      var pauseLog = _this$props3.pauseLog; // eslint-disable-line no-shadow

      pauseLog(logId);
    }, _this.triggerResumeLog = function () {
      var _this$props4 = _this.props;
      var logId = _this$props4.logId;
      var resumeLog = _this$props4.resumeLog; // eslint-disable-line no-shadow

      resumeLog(logId);
    }, _this.clearLogOutput = function () {
      var _this$props5 = _this.props;
      var logId = _this$props5.logId;
      var clearLogOutput = _this$props5.clearLogOutput; // eslint-disable-line no-shadow

      clearLogOutput(logId);
    }, _this.toggleScrollLock = function () {
      var _this$props6 = _this.props;
      var logId = _this$props6.logId;
      var toggleScrollLock = _this$props6.toggleScrollLock; // eslint-disable-line no-shadow

      toggleScrollLock(logId);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(LogPageHeader, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      /*  Component should only update when IDs, name, file name, file path,
       *  activeState or extraActionsOpen change.
       */
      return this.props.logId !== nextProps.logId || this.props.log.name !== nextProps.log.name || this.props.log.fpath !== nextProps.log.fpath || this.props.log.fname !== nextProps.log.fname || this.props.log.activeState !== nextProps.log.activeState || this.props.log.extraActionsOpen !== nextProps.log.extraActionsOpen || this.props.log.scrollLocked !== nextProps.log.scrollLocked;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('LogPageHeader:cDU');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var logId = _props.logId;
      var log = _props.log;
      var toggleLogExtraActionsOpen = _props.toggleLogExtraActionsOpen; // eslint-disable-line no-shadow

      // Control buttons depending on log active state

      var headerActions = undefined;
      switch (log.activeState) {
        case 'ACTIVE':
          headerActions = [_react3.default.createElement(_components2.ControlButton, { key: 0, iconName: 'pause', text: 'Pause watching', color: 'warning', onClick: this.triggerPauseLog }), _react3.default.createElement(_components2.ControlButton, { key: 1, iconName: 'stop', text: 'Stop watching', color: 'negative', onClick: this.triggerDeactivateLog })];
          break;
        case 'PAUSED':
          headerActions = [_react3.default.createElement(_components2.ControlButton, { key: 0, iconName: 'play', text: 'Resume watching', color: 'positive', onClick: this.triggerResumeLog }), _react3.default.createElement(_components2.ControlButton, { key: 1, iconName: 'stop', text: 'Stop watching', color: 'negative', onClick: this.triggerDeactivateLog })];
          break;
        case 'INACTIVE':
        // Use default
        case 'INACTIVE_WITH_OUTPUT':
        // Use default
        default:
          headerActions = [_react3.default.createElement(_components2.ControlButton, { key: 0, iconName: 'play', text: 'Start watching', color: 'positive', onClick: this.triggerActivateLog })];
          break;
      }

      return _react3.default.createElement(
        'header',
        { className: _LogPageHeader2.default.logPageHeader },
        _react3.default.createElement(
          'div',
          { className: _LogPageHeader2.default.row },
          _react3.default.createElement(
            'h2',
            null,
            log.name
          ),
          _react3.default.createElement(
            'div',
            { className: _LogPageHeader2.default.rhs },
            headerActions,
            ',',
            _react3.default.createElement(_components2.ControlButton, { key: 1, iconName: 'delete', text: 'Clear output', color: 'negative', onClick: this.clearLogOutput }),
            _react3.default.createElement(_components2.ControlButton, { iconName: log.scrollLocked ? 'lock-open' : 'lock', text: (log.scrollLocked ? 'Unl' : 'L') + 'ock scrolling', color: 'neutral', onClick: this.toggleScrollLock })
          )
        ),
        _react3.default.createElement(
          'div',
          { className: _LogPageHeader2.default.row + (_config.releaseStage < 3 ? ' ' + _LogPageHeader2.default.earlyReleaseStyle : '') },
          _react3.default.createElement(
            'h3',
            { title: log.fpath + log.fname },
            log.fpath + log.fname
          ),
          _config.releaseStage > 2 ? _react3.default.createElement(
            'div',
            { className: _LogPageHeader2.default.rhs },
            _react3.default.createElement(
              'button',
              { className: log.extraActionsOpen ? _LogPageHeader2.default.toggle : _LogPageHeader2.default.toggle + ' ' + _LogPageHeader2.default.closed, onClick: toggleLogExtraActionsOpen.bind(null, logId) },
              _react3.default.createElement(
                'span',
                null,
                log.extraActionsOpen ? 'Hide' : 'Show'
              ),
              _react3.default.createElement(_components2.Icon, { iconName: 'chevron-down' })
            )
          ) : null
        ),
        _config.releaseStage > 2 ? [_react3.default.createElement(
          'div',
          { className: _LogPageHeader2.default.row, style: log.extraActionsOpen ? { maxHeight: '40px', paddingTop: '12px' } : {} },
          _react3.default.createElement(_components2.DropDown, { title: 'Syntax', options: [], onChange: function onChange() {} }),
          _react3.default.createElement(_components2.DropDown, { title: 'Filter', options: [], onChange: function onChange() {} })
        ), _react3.default.createElement(
          'div',
          { className: _LogPageHeader2.default.row },
          _react3.default.createElement(
            'nav',
            null,
            _react3.default.createElement(
              'ul',
              null,
              _react3.default.createElement(
                'li',
                null,
                _react3.default.createElement(
                  _reactRouter.Link,
                  { to: '/dashboard/log/' + logId + '/output' },
                  'Output'
                )
              ),
              _react3.default.createElement(
                'li',
                null,
                _react3.default.createElement(
                  _reactRouter.Link,
                  { to: '/dashboard/log/' + logId + '/analysis' },
                  'Analysis'
                )
              )
            )
          )
        )] : null
      );
    }
  }]);
  return LogPageHeader;
}(_react2.Component), _class2.propTypes = {
  logId: _react2.PropTypes.string.isRequired,
  log: _react2.PropTypes.object.isRequired,
  toggleLogExtraActionsOpen: _react2.PropTypes.func.isRequired,
  activateLog: _react2.PropTypes.func.isRequired,
  pauseLog: _react2.PropTypes.func.isRequired,
  resumeLog: _react2.PropTypes.func.isRequired,
  deactivateLog: _react2.PropTypes.func.isRequired,
  clearLogOutput: _react2.PropTypes.func.isRequired,
  toggleScrollLock: _react2.PropTypes.func.isRequired
}, _temp2)) || _class));

exports.default = LogPageHeader;
module.exports = exports['default'];