'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _dec, _class, _class2, _temp;

var _reactRouter = require('react-router');

var _components2 = require('../../components');

var _NavPanel = require('./NavPanel.scss');

var _NavPanel2 = _interopRequireDefault(_NavPanel);

var _reactRedux = require('react-redux');

var _appInterface = require('../../redux/modules/appInterface');

var _groups = require('../../redux/modules/groups');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  NavPanel: {
    displayName: 'NavPanel'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/NavPanel/NavPanel.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var NavPanel = _wrapComponent('NavPanel')((_dec = (0, _reactRedux.connect)(function (state) {
  return {
    activeGroupOpen: state.appInterface.activeGroupNavOpen
  };
}, { toggleActiveNavGroupOpen: _appInterface.toggleActiveNavGroupOpen, toggleNavGroupOpen: _groups.toggleNavGroupOpen }), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(NavPanel, _Component);

  function NavPanel() {
    (0, _classCallCheck3.default)(this, NavPanel);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(NavPanel).apply(this, arguments));
  }

  (0, _createClass3.default)(NavPanel, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('NavPanel:cDU');
    }
  }, {
    key: 'toggleNavGroupOpen',
    value: function toggleNavGroupOpen(groupId) {
      var _props = this.props;
      var toggleNavGroupOpen = _props.toggleNavGroupOpen;
      var toggleActiveNavGroupOpen = _props.toggleActiveNavGroupOpen; // eslint-disable-line

      if (!groupId) {
        // Is active group, use different function
        toggleActiveNavGroupOpen();
      } else {
        toggleNavGroupOpen(groupId);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props;
      var authEnabled = _props2.authEnabled;
      var activeGroupOpen = _props2.activeGroupOpen;
      var groups = _props2.groups;
      var logs = _props2.logs;

      /* Normalise both normal and active groups to format:
      {
        groupId,
        groupName,
        groupNavOpen,
        logs : [
          {
            logId,
            groupId,
            logName,
            logStatus,
            logHasNew
          }
        ]
      }
      */

      var navGroups = [];
      var activeLogs = [];

      (0, _keys2.default)(groups).forEach(function (groupId) {
        var group = groups[groupId];
        var groupLogs = [];

        group.logs.forEach(function (logId) {
          var log = logs[logId];

          // Add log to group list
          groupLogs.push({
            logId: logId,
            logName: log.name,
            logStatus: log.activeState,
            logHasNew: log.hasNew
          });

          // Add log to active list if isn't inactive
          if (log.activeState !== 'INACTIVE') {
            activeLogs.push({
              logId: logId,
              logName: log.name,
              logStatus: log.activeState,
              logHasNew: log.hasNew
            });
          }
        });

        groupLogs.sort(function (first, second) {
          return first.logName.localeCompare(second.logName);
        });

        navGroups.push({
          groupId: groupId,
          logs: groupLogs,
          groupName: group.name,
          groupNavOpen: group.navOpen
        });
      });

      // Sort groups based on name
      navGroups.sort(function (first, second) {
        return first.groupName.localeCompare(second.groupName);
      });

      // Sort active logs and push to start of list
      activeLogs.sort(function (first, second) {
        return first.logName.localeCompare(second.logName);
      });
      navGroups.unshift({
        groupName: 'Active Group',
        groupNavOpen: activeGroupOpen,
        logs: activeLogs
      });

      return _react3.default.createElement(
        'aside',
        null,
        _react3.default.createElement(
          'div',
          { className: _NavPanel2.default.logo },
          _react3.default.createElement(
            _reactRouter.Link,
            { to: '/dashboard' },
            _react3.default.createElement(_components2.Icon, { iconName: 'logger-logo', viewBox: '0 0 123.1 34' })
          )
        ),
        _react3.default.createElement(
          'nav',
          null,
          _react3.default.createElement(
            'div',
            null,
            _react3.default.createElement(
              'div',
              null,
              navGroups.map(function (group, index) {
                return _react3.default.createElement(_components2.NavPanelGroup, { key: index, groupId: group.groupId, groupName: group.groupName, groupNavOpen: group.groupNavOpen, logs: group.logs, toggleNavOpen: _this2.toggleNavGroupOpen.bind(_this2, group.groupId) });
              })
            )
          ),
          _react3.default.createElement(
            'div',
            null,
            _react3.default.createElement(
              'ul',
              null,
              _react3.default.createElement(
                'li',
                null,
                _react3.default.createElement(
                  _reactRouter.Link,
                  { to: '/dashboard/settings' },
                  _react3.default.createElement(_components2.Icon, { iconName: 'settings' }),
                  _react3.default.createElement(
                    'span',
                    null,
                    'Settings'
                  )
                )
              ),
              authEnabled ? [_react3.default.createElement(
                'li',
                null,
                _react3.default.createElement(
                  _reactRouter.Link,
                  { to: 'about' },
                  _react3.default.createElement(_components2.Icon, { iconName: 'account' }),
                  _react3.default.createElement(
                    'span',
                    null,
                    'Your Account'
                  )
                )
              ), _react3.default.createElement(
                'li',
                null,
                _react3.default.createElement(
                  _reactRouter.Link,
                  { to: 'logout' },
                  _react3.default.createElement(_components2.Icon, { iconName: 'logout' }),
                  _react3.default.createElement(
                    'span',
                    null,
                    'Sign Out'
                  )
                )
              )] : null
            )
          )
        )
      );
    }
  }]);
  return NavPanel;
}(_react2.Component), _class2.propTypes = {
  authEnabled: _react2.PropTypes.bool,
  activeGroupOpen: _react2.PropTypes.bool,
  toggleNavGroupOpen: _react2.PropTypes.func,
  toggleActiveNavGroupOpen: _react2.PropTypes.func,
  groups: _react2.PropTypes.object.isRequired,
  logs: _react2.PropTypes.object.isRequired
}, _temp)) || _class));

exports.default = NavPanel;
module.exports = exports['default'];