'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp;

var _reactRouter = require('react-router');

var _components2 = require('../../components');

var _NavPanelGroup = require('./NavPanelGroup.scss');

var _NavPanelGroup2 = _interopRequireDefault(_NavPanelGroup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  NavPanelGroup: {
    displayName: 'NavPanelGroup'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/NavPanelGroup/NavPanelGroup.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var NavPanelGroup = _wrapComponent('NavPanelGroup')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(NavPanelGroup, _Component);

  function NavPanelGroup() {
    (0, _classCallCheck3.default)(this, NavPanelGroup);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(NavPanelGroup).apply(this, arguments));
  }

  (0, _createClass3.default)(NavPanelGroup, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      /*  This component should only update if the IDs, name, activeState or
       *  isVisisble values change.
       *
       *  This is actually a lot more elegant than it may seem as if say the
       *  group name is the change, the later comparisons won't actually be made.
       */
      return this.props.groupId !== nextProps.groupId || this.props.groupName !== nextProps.groupName || this.props.groupNavOpen !== nextProps.groupNavOpen || this.props.logs.length !== nextProps.logs.length || this.props.logs.reduce(function (prevValue, currLog, index) {
        var nextLog = nextProps.logs[index];
        return prevValue || currLog.logId !== nextLog.logId || currLog.groupId !== nextLog.groupId || currLog.logName !== nextLog.logName || currLog.logStatus !== nextLog.logStatus || currLog.logHasNew !== nextLog.logHasNew;
      }, false);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('NavPanelGroup:cDU - ' + this.props.groupName);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var groupId = _props.groupId;
      var groupName = _props.groupName;
      var groupNavOpen = _props.groupNavOpen;
      var toggleNavOpen = _props.toggleNavOpen;
      var logs = _props.logs; // eslint-disable-line no-shadow

      var listContentsHeight = logs.length * 30 || 19; // ##BADCODE Hard coded styling related value, the OR is for when the log list is empty and 'No logs' is shown
      var currHeight = (groupNavOpen ? listContentsHeight : '0') + 'px';
      return _react3.default.createElement(
        'section',
        { className: _NavPanelGroup2.default.navPanelGroup },
        _react3.default.createElement(
          'header',
          null,
          _react3.default.createElement(
            'div',
            null,
            _react3.default.createElement(
              _reactRouter.Link,
              { to: !groupId ? '/dashboard/active' : '/dashboard/group/' + groupId },
              _react3.default.createElement(
                'h3',
                { title: groupName },
                groupName
              )
            )
          ),
          _react3.default.createElement(
            'button',
            { onClick: toggleNavOpen, className: groupNavOpen ? '' : _NavPanelGroup2.default.closed },
            _react3.default.createElement(_components2.Icon, { iconName: 'chevron-down' })
          )
        ),
        _react3.default.createElement(
          'ul',
          { ref: 'list', style: { height: currHeight } },
          logs.length > 0 ? logs.map(function (log, index) {
            return _react3.default.createElement(_components2.NavPanelGroupItem, (0, _extends3.default)({ key: index }, log, { isVisible: groupNavOpen }));
          }) : _react3.default.createElement(
            'li',
            { className: _NavPanelGroup2.default.noLogsLine },
            'No logs'
          )
        )
      );
    }
  }]);
  return NavPanelGroup;
}(_react2.Component), _class.propTypes = {
  groupId: _react2.PropTypes.string,
  groupName: _react2.PropTypes.string.isRequired,
  groupNavOpen: _react2.PropTypes.bool.isRequired,
  toggleNavOpen: _react2.PropTypes.func.isRequired,
  logs: _react2.PropTypes.array.isRequired
}, _temp));

exports.default = NavPanelGroup;
module.exports = exports['default'];