'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp;

var _reactRouter = require('react-router');

var _NavPanelGroupItem = require('./NavPanelGroupItem.scss');

var _NavPanelGroupItem2 = _interopRequireDefault(_NavPanelGroupItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  NavPanelGroupItem: {
    displayName: 'NavPanelGroupItem'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/NavPanelGroupItem/NavPanelGroupItem.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var NavPanelGroupItem = _wrapComponent('NavPanelGroupItem')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(NavPanelGroupItem, _Component);

  function NavPanelGroupItem() {
    (0, _classCallCheck3.default)(this, NavPanelGroupItem);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(NavPanelGroupItem).apply(this, arguments));
  }

  (0, _createClass3.default)(NavPanelGroupItem, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      /*  This component should only update if the IDs, name, activeState or
       *  isVisisble values change.
       */
      return this.props.logId !== nextProps.logId || this.props.logName !== nextProps.logName || this.props.logStatus !== nextProps.logStatus || this.props.logHasNew !== nextProps.logHasNew || this.props.isVisible !== nextProps.isVisible;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var logId = _props.logId;
      var logName = _props.logName;
      var logStatus = _props.logStatus;
      var logHasNew = _props.logHasNew;
      var isVisible = _props.isVisible;

      var colorClass = undefined;
      var activeTitle = undefined;
      switch (logStatus) {
        case 'ACTIVE':
          colorClass = logHasNew ? _NavPanelGroupItem2.default.active : _NavPanelGroupItem2.default.idle;
          activeTitle = logHasNew ? 'Has updates' : 'Watching for updates';
          break;
        case 'PAUSED':
          colorClass = _NavPanelGroupItem2.default.paused;
          activeTitle = 'Updating paused';
          break;
        case 'INACTIVE_WITH_OUTPUT':
          colorClass = _NavPanelGroupItem2.default.hasOutput;
          activeTitle = 'Inactive with output';
          break;
        default:
          colorClass = '';
          activeTitle = 'Inactive';
          break;
      }

      return _react3.default.createElement(
        'li',
        { className: _NavPanelGroupItem2.default.navPanelGroupItem },
        _react3.default.createElement(
          _reactRouter.Link,
          { to: '/dashboard/log/' + logId, tabIndex: isVisible ? '0' : '-1', title: logName + ' - ' + activeTitle },
          _react3.default.createElement('i', { className: colorClass }),
          _react3.default.createElement(
            'span',
            null,
            logName
          )
        )
      );
    }
  }]);
  return NavPanelGroupItem;
}(_react2.Component), _class.propTypes = {
  logId: _react2.PropTypes.string.isRequired,
  logName: _react2.PropTypes.string.isRequired,
  logStatus: _react2.PropTypes.string.isRequired,
  logHasNew: _react2.PropTypes.bool.isRequired,
  isVisible: _react2.PropTypes.bool
}, _temp));

exports.default = NavPanelGroupItem;
module.exports = exports['default'];