'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _dec, _class, _class2, _temp;

var _Notification = require('./Notification.scss');

var _Notification2 = _interopRequireDefault(_Notification);

var _reactRedux = require('react-redux');

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _components2 = require('../../components');

var _notifications = require('../../redux/modules/notifications.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  Notification: {
    displayName: 'Notification'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/Notification/Notification.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var Notification = _wrapComponent('Notification')((_dec = (0, _reactRedux.connect)(null, { clearNotification: _notifications.clearNotification }), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(Notification, _Component);

  function Notification() {
    (0, _classCallCheck3.default)(this, Notification);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Notification).call(this));

    _this.pauseProgress = function () {
      clearInterval(_this.state.intervalId);
    };

    _this.startProgress = function () {
      if (!_this.state.intervalId) {
        (function () {
          var duration = 20000; // 10s
          var steps = 1200; // 1200 = 60fps
          var intervalId = setInterval(function () {
            if (_this.state.progress < 1) {
              _this.setState({ progress: _this.state.progress + 1 / steps });
            } else {
              // Clear panel
              clearInterval(_this.state.intervalId);
              _this.setState({ intervalId: null });
              _this.closeNotification();
            }
          }, duration / steps);
          _this.setState({ intervalId: intervalId });
        })();
      }
    };

    _this.closeNotification = function () {
      _this.setState({ isClosing: true });
      setTimeout(function () {
        return _this.props.clearNotification(_this.props.position);
      }, 500);
    };

    _this.state = {
      progress: 0,
      intervalId: null,
      isOpening: true,
      isClosing: false
    };
    return _this;
  }

  (0, _createClass3.default)(Notification, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      // Set auto clear count down if is INFO
      if (this.props.notification.type === 'INFO') {
        this.startProgress();
      }
      if (__CLIENT__) {
        setTimeout(function () {
          return _this2.setState({ isOpening: false });
        }, 500);
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return nextState.progress !== this.state.progress || nextState.isOpening !== this.state.isOpening || nextState.isClosing !== this.state.isClosing || nextProps.notification.type !== this.props.notification.type || nextProps.notification.message !== this.props.notification.message;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearInterval(this.state.intervalId);
    }
  }, {
    key: 'render',
    value: function render() {
      var _classnames;

      var notification = this.props.notification; // eslint-disable-line

      var _state = this.state;
      var progress = _state.progress;
      var isOpening = _state.isOpening;
      var isClosing = _state.isClosing;

      var cname = (0, _classnames3.default)(_Notification2.default.notification, (_classnames = {}, (0, _defineProperty3.default)(_classnames, _Notification2.default.opening, isOpening), (0, _defineProperty3.default)(_classnames, _Notification2.default.closing, isClosing), (0, _defineProperty3.default)(_classnames, _Notification2.default.errorPanel, notification.type === 'ERROR'), (0, _defineProperty3.default)(_classnames, _Notification2.default.infoPanel, notification.type === 'INFO'), _classnames));

      var displayedProgress = progress > 1 ? 100 : 100 * progress;
      var endBorderRadius = displayedProgress < 99 ? 0 : (displayedProgress - 99) * 4;

      return _react3.default.createElement(
        'div',
        { className: cname, onMouseEnter: notification.type === 'INFO' && this.pauseProgress, onMouseLeave: notification.type === 'INFO' && this.startProgress },
        _react3.default.createElement(
          'p',
          null,
          notification.message
        ),
        _react3.default.createElement(
          'button',
          { onClick: this.closeNotification },
          _react3.default.createElement(_components2.Icon, { iconName: 'close' })
        ),
        notification.type === 'INFO' && _react3.default.createElement('div', { className: _Notification2.default.autoClearBar, style: { width: displayedProgress + '%', borderBottomRightRadius: endBorderRadius + 'px' } })
      );
    }
  }]);
  return Notification;
}(_react2.Component), _class2.propTypes = {
  position: _react2.PropTypes.number.isRequired,
  notification: _react2.PropTypes.object.isRequired,
  clearNotification: _react2.PropTypes.func.isRequired
}, _temp)) || _class));

exports.default = Notification;
module.exports = exports['default'];