'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _dec, _class, _class2, _temp2;

var _reactRedux = require('react-redux');

var _logs = require('../../redux/modules/logs');

var _sharedActions = require('../../redux/modules/sharedActions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  SocketEventHandler: {
    displayName: 'SocketEventHandler'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/SocketEventHandler/SocketEventHandler.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var SocketEventHandler = _wrapComponent('SocketEventHandler')((_dec = (0, _reactRedux.connect)(null, {
  addLineToLog: _logs.addLineToLog,
  newGroupEmitted: _sharedActions.newGroupEmitted,
  groupNameChangeEmitted: _sharedActions.groupNameChangeEmitted,
  groupDeleteEmitted: _sharedActions.groupDeleteEmitted,
  newLogEmitted: _sharedActions.newLogEmitted,
  logDeleteEmitted: _sharedActions.logDeleteEmitted,
  tailErrorEmitted: _sharedActions.tailErrorEmitted,
  logNameChangeEmitted: _sharedActions.logNameChangeEmitted,
  logGroupChangeEmitted: _sharedActions.logGroupChangeEmitted,
  logFileChangeEmitted: _sharedActions.logFileChangeEmitted,
  logPathChangeEmitted: _sharedActions.logPathChangeEmitted
}), _dec(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(SocketEventHandler, _Component);

  function SocketEventHandler() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, SocketEventHandler);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_Object$getPrototypeO = (0, _getPrototypeOf2.default)(SocketEventHandler)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.setTailError = function (data) {
      return _this.props.tailErrorEmitted(data.logId, data.errorReason, data.errorCode);
    }, _this.addLineToLog = function (data) {
      return _this.props.addLineToLog(data.logId, data.newLine);
    }, _this.newGroupEmitted = function (data) {
      return _this.props.newGroupEmitted(data.newGroupId, data.newGroupName);
    }, _this.groupNameChangeEmitted = function (data) {
      return _this.props.groupNameChangeEmitted(data.groupId, data.newName, data.oldName);
    }, _this.groupDeleteEmitted = function (data) {
      return _this.props.groupDeleteEmitted(data.groupId, data.logIds, data.groupName);
    }, _this.newLogEmitted = function (data) {
      return _this.props.newLogEmitted('' + data.newLogId, data.logName, '' + data.groupId, data.logFile, data.logPath, data.groupName);
    }, _this.logDeleteEmitted = function (data) {
      return _this.props.logDeleteEmitted(data.groupId, data.logId, data.logName, data.groupName);
    }, _this.logNameChangeEmitted = function (data) {
      return _this.props.logNameChangeEmitted(data.logId, data.newName, data.oldName);
    }, _this.logGroupChangeEmitted = function (data) {
      return _this.props.logGroupChangeEmitted(data.logId, data.logName, data.newGroupName, data.oldGroupName, data.newGroupId, data.oldGroupId);
    }, _this.logFileChangeEmitted = function (data) {
      return _this.props.logFileChangeEmitted(data.logId, data.logName, data.newFile, data.oldFile);
    }, _this.logPathChangeEmitted = function (data) {
      return _this.props.logPathChangeEmitted(data.logId, data.logName, data.newPath, data.oldPath);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(SocketEventHandler, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      // Mount all socket listeners here
      socket.on('tail:failure', this.setTailError);
      socket.on('lineUpdate', this.addLineToLog);
      socket.on('group:newGroup', this.newGroupEmitted);
      socket.on('group:nameChange', this.groupNameChangeEmitted);
      socket.on('group:groupDelete', this.groupDeleteEmitted);
      socket.on('log:newLog', this.newLogEmitted);
      socket.on('log:logDelete', this.logDeleteEmitted);
      socket.on('log:nameChange', this.logNameChangeEmitted);
      socket.on('log:groupChange', this.logGroupChangeEmitted);
      socket.on('log:fileChange', this.logFileChangeEmitted);
      socket.on('log:pathChange', this.logPathChangeEmitted);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      // Unmount all socket listeners here
      socket.removeListener('tail:failure', this.setTailError);
      socket.removeListener('lineUpdate', this.addLineToLog);
      socket.removeListener('group:newGroup', this.newGroupEmitted);
      socket.removeListener('group:nameChange', this.groupNameChangeEmitted);
      socket.removeListener('group:groupDelete', this.groupDeleteEmitted);
      socket.removeListener('log:newLog', this.newLogEmitted);
      socket.removeListener('log:logDelete', this.logDeleteEmitted);
      socket.removeListener('log:nameChange', this.logNameChangeEmitted);
      socket.removeListener('log:groupChange', this.logGroupChangeEmitted);
      socket.removeListener('log:fileChange', this.logFileChangeEmitted);
      socket.removeListener('log:pathChange', this.logPathChangeEmitted);
    }
  }, {
    key: 'render',
    value: function render() {
      return null;
    }
  }]);
  return SocketEventHandler;
}(_react2.Component), _class2.propTypes = {
  addLineToLog: _react2.PropTypes.func.isRequired,
  newGroupEmitted: _react2.PropTypes.func.isRequired,
  groupNameChangeEmitted: _react2.PropTypes.func.isRequired,
  groupDeleteEmitted: _react2.PropTypes.func.isRequired,
  newLogEmitted: _react2.PropTypes.func.isRequired,
  logDeleteEmitted: _react2.PropTypes.func.isRequired,
  tailErrorEmitted: _react2.PropTypes.func.isRequired,
  logNameChangeEmitted: _react2.PropTypes.func.isRequired,
  logGroupChangeEmitted: _react2.PropTypes.func.isRequired,
  logFileChangeEmitted: _react2.PropTypes.func.isRequired,
  logPathChangeEmitted: _react2.PropTypes.func.isRequired
}, _temp2)) || _class));

exports.default = SocketEventHandler;
module.exports = exports['default'];