'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _dec, _dec2, _class, _class2, _temp;

var _groups = require('../../redux/modules/groups');

var _logs = require('../../redux/modules/logs');

var _appManagement = require('../../redux/modules/appManagement');

var _connectData = require('../../helpers/connectData');

var _connectData2 = _interopRequireDefault(_connectData);

var _reactRedux = require('react-redux');

var _components2 = require('../../components');

var _Dashboard = require('./Dashboard.scss');

var _Dashboard2 = _interopRequireDefault(_Dashboard);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  Dashboard: {
    displayName: 'Dashboard'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/containers/Dashboard/Dashboard.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

function fetchData(getState, dispatch) {
  var promises = [];
  if (!(0, _groups.isLoaded)(getState())) {
    promises.push(dispatch((0, _groups.load)()));
  }
  if (!(0, _logs.isLoaded)(getState())) {
    promises.push(dispatch((0, _logs.load)()));
  }
  if (!(0, _appManagement.isLoaded)(getState())) {
    promises.push(dispatch((0, _appManagement.load)()));
  }
  return _promise2.default.all(promises);
}

var Dashboard = _wrapComponent('Dashboard')((_dec = (0, _connectData2.default)(fetchData), _dec2 = (0, _reactRedux.connect)(function (state) {
  return {
    authEnabled: state.auth.enabled,
    groups: state.groups.data,
    logs: state.logs.data
  };
}), _dec(_class = _dec2(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(Dashboard, _Component);

  function Dashboard() {
    (0, _classCallCheck3.default)(this, Dashboard);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Dashboard).apply(this, arguments));
  }

  (0, _createClass3.default)(Dashboard, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var authEnabled = _props.authEnabled;
      var groups = _props.groups;
      var logs = _props.logs;

      return _react3.default.createElement(
        'div',
        { className: _Dashboard2.default.dashboard },
        _react3.default.createElement(_components2.SocketEventHandler, null),
        _react3.default.createElement(_components2.NavPanel, { authEnabled: authEnabled, groups: groups, logs: logs }),
        _react3.default.createElement(
          'main',
          null,
          this.props.children,
          _react3.default.createElement(_components2.NotificationArea, null)
        )
      );
    }
  }]);
  return Dashboard;
}(_react2.Component), _class2.propTypes = {
  children: _react2.PropTypes.object.isRequired,
  authEnabled: _react2.PropTypes.bool,
  groups: _react2.PropTypes.object.isRequired,
  logs: _react2.PropTypes.object.isRequired
}, _temp)) || _class) || _class));

exports.default = Dashboard;
module.exports = exports['default'];