'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _dec, _class, _class2, _temp2;

var _reactRedux = require('react-redux');

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

var _auth = require('../../redux/modules/auth');

var authActions = _interopRequireWildcard(_auth);

var _Login = require('./Login.scss');

var _Login2 = _interopRequireDefault(_Login);

var _components2 = require('../../components');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  Login: {
    displayName: 'Login'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/containers/Login/Login.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var Login = _wrapComponent('Login')((_dec = (0, _reactRedux.connect)(function (state) {
  return {
    user: state.auth.user,
    loggingIn: state.auth.loggingIn,
    loginError: state.auth.loginError
  };
}, authActions), _dec(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(Login, _Component);

  function Login() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Login);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_Object$getPrototypeO = (0, _getPrototypeOf2.default)(Login)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.handleSubmit = function (event) {
      event.preventDefault();
      var username = _this.refs.username.value;
      var password = _this.refs.password.value;
      _this.props.login(username, password);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Login, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var loggingIn = _props.loggingIn;
      var loginError = _props.loginError;

      var usernameError = loginError && loginError.errorField === 'username';
      var passwordError = loginError && loginError.errorField === 'password';
      var errorMessage = usernameError || passwordError ? loginError.errorReason : '.';
      return _react3.default.createElement(
        'main',
        { className: _Login2.default.loginPage },
        _react3.default.createElement(_reactHelmet2.default, { title: 'Login' }),
        _react3.default.createElement(
          'section',
          { className: loggingIn ? _Login2.default.hiddenAbove : '' },
          _react3.default.createElement(
            'form',
            { onSubmit: this.handleSubmit },
            _react3.default.createElement(
              'h1',
              null,
              'Sign in'
            ),
            _react3.default.createElement('input', { type: 'text', ref: 'username', placeholder: 'Username', className: usernameError ? _Login2.default.inputError : '' }),
            _react3.default.createElement(
              'p',
              { className: usernameError || passwordError ? _Login2.default.showError : '' },
              errorMessage
            ),
            _react3.default.createElement('input', { type: 'password', ref: 'password', placeholder: 'Password', className: passwordError ? _Login2.default.inputError : '' }),
            _react3.default.createElement('input', { type: 'checkbox', ref: 'rememberme', id: 'rememberme' }),
            _react3.default.createElement(
              'label',
              { htmlFor: 'rememberme' },
              'Remember me'
            ),
            _react3.default.createElement(
              'button',
              { onClick: this.handleSubmit },
              'Submit'
            )
          )
        ),
        _react3.default.createElement(
          'section',
          { className: loggingIn ? _Login2.default.hiddenBellow : '' },
          _react3.default.createElement(
            'div',
            null,
            _react3.default.createElement(_components2.LoadingSpinner, null),
            _react3.default.createElement(
              'span',
              null,
              'Signing in'
            )
          )
        )
      );
    }
  }]);
  return Login;
}(_react2.Component), _class2.propTypes = {
  login: _react2.PropTypes.func,
  loggingIn: _react2.PropTypes.bool,
  loginError: _react2.PropTypes.object
}, _temp2)) || _class));

exports.default = Login;
module.exports = exports['default'];