'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _NotFound = require('./NotFound.scss');

var _NotFound2 = _interopRequireDefault(_NotFound);

var _reactRouter = require('react-router');

var _components2 = require('../../components');

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  NotFound: {
    displayName: 'NotFound'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/containers/NotFound/NotFound.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var maxMovementPercentage = 1;

var NotFound = _wrapComponent('NotFound')(function (_Component) {
  (0, _inherits3.default)(NotFound, _Component);

  function NotFound() {
    (0, _classCallCheck3.default)(this, NotFound);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(NotFound).call(this));

    _this.state = {
      widthPercentage: 0.5,
      heightPercentage: 0.5
    };
    return _this;
  }

  (0, _createClass3.default)(NotFound, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      document.onmousemove = function (event) {
        _this2.setState({
          widthPercentage: event.pageX / window.innerWidth,
          heightPercentage: event.pageY / window.innerHeight
        });
      };
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.onmousemove = undefined;
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state;
      var widthPercentage = _state.widthPercentage;
      var heightPercentage = _state.heightPercentage;

      var leftModifier = (widthPercentage - 0.5) * maxMovementPercentage;
      var topModifier = (heightPercentage - 0.5) * maxMovementPercentage;
      var containerLeft = leftModifier * -2 + 50;
      var containerTop = topModifier * -2 + 50;
      var backgroundLeft = leftModifier * 3 - 50;
      var backgroundTop = topModifier * 3 - 50;
      return _react3.default.createElement(
        'main',
        { className: _NotFound2.default.notFound },
        _react3.default.createElement(_reactHelmet2.default, { title: 'Not Found - 404' }),
        _react3.default.createElement('div', { className: _NotFound2.default.bg, style: { left: backgroundLeft + '%', top: backgroundTop + '%' } }),
        _react3.default.createElement(
          'div',
          { className: _NotFound2.default.container, style: { left: containerLeft + '%', top: containerTop + '%' } },
          _react3.default.createElement(
            'div',
            { className: _NotFound2.default.transform },
            _react3.default.createElement(
              _reactRouter.Link,
              { to: '/dashboard' },
              _react3.default.createElement(_components2.Icon, { iconName: 'keyboard-backspace' }),
              _react3.default.createElement(
                'span',
                null,
                'Dashboard'
              )
            ),
            _react3.default.createElement(
              'h1',
              null,
              '404'
            ),
            _react3.default.createElement(
              'p',
              null,
              'This is not the page you are looking for'
            )
          )
        )
      );
    }
  }]);
  return NotFound;
}(_react2.Component));

exports.default = NotFound;
module.exports = exports['default'];