'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp;

var _server = require('react-dom/server');

var _server2 = _interopRequireDefault(_server);

var _serializeJavascript = require('serialize-javascript');

var _serializeJavascript2 = _interopRequireDefault(_serializeJavascript);

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

var _uglifyJs = require('uglify-js');

var _uglifyJs2 = _interopRequireDefault(_uglifyJs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  Html: {
    displayName: 'Html'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/helpers/Html.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

/**
 * Wrapper component containing HTML metadata and boilerplate tags.
 * Used in server-side code only to wrap the string output of the
 * rendered route component.
 *
 * The only thing this component doesn't (and can't) include is the
 * HTML doctype declaration, which is added to the rendered output
 * by the server.js file.
 */

var Html = _wrapComponent('Html')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(Html, _Component);

  function Html() {
    (0, _classCallCheck3.default)(this, Html);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Html).apply(this, arguments));
  }

  (0, _createClass3.default)(Html, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var assets = _props.assets;
      var component = _props.component;
      var store = _props.store;

      var content = component ? _server2.default.renderToString(component) : '';
      var head = _reactHelmet2.default.rewind();

      // Uglify expects valid JavaScript, not JSON, so we need to assign the
      // store object to a variable and then remove the assignment after
      var storeData = (0, _serializeJavascript2.default)(store.getState());
      var temporaryAssign = 'var removeme=';
      var minifiedStoreData = _uglifyJs2.default.minify(temporaryAssign + storeData, { fromString: true }).code.substring(temporaryAssign.length);

      return _react3.default.createElement(
        'html',
        { lang: 'en-us' },
        _react3.default.createElement(
          'head',
          null,
          head.base.toComponent(),
          head.title.toComponent(),
          head.meta.toComponent(),
          head.link.toComponent(),
          head.script.toComponent(),
          _react3.default.createElement('link', { rel: 'shortcut icon', href: '/favicon.ico' }),
          _react3.default.createElement('meta', { name: 'viewport', content: 'width=device-width, initial-scale=1' }),
          (0, _keys2.default)(assets.styles).map(function (style, key) {
            return _react3.default.createElement('link', { href: assets.styles[style], key: key, media: 'screen, projection',
              rel: 'stylesheet', type: 'text/css', charSet: 'UTF-8' });
          })
        ),
        _react3.default.createElement(
          'body',
          null,
          _react3.default.createElement('div', { id: 'content', dangerouslySetInnerHTML: { __html: content } }),
          _react3.default.createElement('script', { dangerouslySetInnerHTML: { __html: 'window.__data=' + minifiedStoreData + ';' }, charSet: 'UTF-8' }),
          _react3.default.createElement('script', { src: assets.javascript.main, charSet: 'UTF-8' })
        )
      );
    }
  }]);
  return Html;
}(_react2.Component), _class.propTypes = {
  assets: _react2.PropTypes.object,
  component: _react2.PropTypes.node,
  store: _react2.PropTypes.object
}, _temp));

exports.default = Html;
module.exports = exports['default'];