'use strict';

var _chai = require('chai');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _connectData = require('../connectData');

var _connectData2 = _interopRequireDefault(_connectData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('connectData', function () {
  var fetchData = undefined;
  var fetchDataDeferred = undefined;
  var WrappedComponent = undefined;
  var DataComponent = undefined;

  beforeEach(function () {
    fetchData = 'fetchDataFunction';
    fetchDataDeferred = 'fetchDataDeferredFunction';

    WrappedComponent = function WrappedComponent() {
      return _react2.default.createElement('div', null);
    };

    DataComponent = (0, _connectData2.default)(fetchData, fetchDataDeferred)(WrappedComponent);
  });

  it('should set fetchData as a static property of the final component', function () {
    (0, _chai.expect)(DataComponent.fetchData).to.equal(fetchData);
  });

  it('should set fetchDataDeferred as a static property of the final component', function () {
    (0, _chai.expect)(DataComponent.fetchDataDeferred).to.equal(fetchDataDeferred);
  });
});