'use strict';

var _chai = require('chai');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _getDataDependencies = require('../getDataDependencies');

var _getDataDependencies2 = _interopRequireDefault(_getDataDependencies);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('getDataDependencies', function () {
  var getState = undefined;
  var dispatch = undefined;
  var location = undefined;
  var params = undefined;
  var CompWithFetchData = undefined;
  var CompWithNoData = undefined;
  var CompWithFetchDataDeferred = undefined;
  var NullComponent = null;

  beforeEach(function () {
    getState = 'getState';
    dispatch = 'dispatch';
    location = 'location';
    params = 'params';

    CompWithNoData = function CompWithNoData() {
      return _react2.default.createElement('div', null);
    };

    CompWithFetchData = function CompWithFetchData() {
      return _react2.default.createElement('div', null);
    };

    CompWithFetchData.fetchData = function (_getState, _dispatch, _location, _params) {
      return 'fetchData ' + _getState + ' ' + _dispatch + ' ' + _location + ' ' + _params;
    };
    CompWithFetchDataDeferred = function CompWithFetchDataDeferred() {
      return _react2.default.createElement('div', null);
    };

    CompWithFetchDataDeferred.fetchDataDeferred = function (_getState, _dispatch, _location, _params) {
      return 'fetchDataDeferred ' + _getState + ' ' + _dispatch + ' ' + _location + ' ' + _params;
    };
  });

  it('should get fetchDatas', function () {
    var deps = (0, _getDataDependencies2.default)([NullComponent, CompWithFetchData, CompWithNoData, CompWithFetchDataDeferred], getState, dispatch, location, params);

    (0, _chai.expect)(deps).to.deep.equal(['fetchData getState dispatch location params']);
  });

  it('should get fetchDataDeferreds', function () {
    var deps = (0, _getDataDependencies2.default)([NullComponent, CompWithFetchData, CompWithNoData, CompWithFetchDataDeferred], getState, dispatch, location, params, true);

    (0, _chai.expect)(deps).to.deep.equal(['fetchDataDeferred getState dispatch location params']);
  });
});