'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
  * 1. Skip holes in route component chain and
  * only consider components that implement
  * fetchData or fetchDataDeferred
  *
  * 2. Pull out fetch data methods
  *
  * 3. Call fetch data methods and gather promises
  */

exports.default = function (components, getState, dispatch, location, params, deferred) {
  var methodName = deferred ? 'fetchDataDeferred' : 'fetchData';

  return components.filter(function (component) {
    return component && component[methodName];
  }) // 1
  .map(function (component) {
    return component[methodName];
  }) // 2
  .map(function (fetchData) {
    return fetchData(getState, dispatch, location, params);
  }); // 3
};

module.exports = exports['default'];