'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = appInterface;
exports.toggleActiveNavGroupOpen = toggleActiveNavGroupOpen;
exports.setActiveGroupListFilter = setActiveGroupListFilter;
exports.setDashboardListFilter = setDashboardListFilter;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TOGGLE_ACTIVE_NAV_GROUP_OPEN = 'logger-app/appInterface/TOGGLE_ACTIVE_NAV_GROUP_OPEN';
var SET_ACTIVE_GROUP_LIST_FILTER = 'logger-app/appInterface/SET_ACTIVE_GROUP_LIST_FILTER';
var SET_DASHBOARD_LIST_FILTER = 'logger-app/appInterface/SET_DASHBOARD_LIST_FILTER';

var initialState = {
  activeGroupNavOpen: true,
  activeGroupListFilter: '',
  dashboardListFilter: ''
};

function appInterface() {
  var state = arguments.length <= 0 || arguments[0] === undefined ? initialState : arguments[0];
  var action = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  switch (action.type) {
    case TOGGLE_ACTIVE_NAV_GROUP_OPEN:
      return (0, _extends3.default)({}, state, {
        activeGroupNavOpen: !state.activeGroupNavOpen
      });
    case SET_ACTIVE_GROUP_LIST_FILTER:
      return (0, _extends3.default)({}, state, {
        activeGroupListFilter: action.newListFilter
      });
    case SET_DASHBOARD_LIST_FILTER:
      return (0, _extends3.default)({}, state, {
        dashboardListFilter: action.newListFilter
      });
    default:
      return state;
  }
}

function toggleActiveNavGroupOpen() {
  return {
    type: TOGGLE_ACTIVE_NAV_GROUP_OPEN
  };
}

function setActiveGroupListFilter(newListFilter) {
  return {
    type: SET_ACTIVE_GROUP_LIST_FILTER,
    newListFilter: newListFilter
  };
}

function setDashboardListFilter(newListFilter) {
  return {
    type: SET_DASHBOARD_LIST_FILTER,
    newListFilter: newListFilter
  };
}