'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = reducer;
exports.setNewGroupName = setNewGroupName;
exports.toggleInputingNewGroup = toggleInputingNewGroup;
exports.createNewGroup = createNewGroup;

var _sharedActions = require('./sharedActions.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SET_NEW_GROUP_NAME = 'logger-app/groupManagement/SET_NEW_GROUP_NAME';
var TOGGLE_INPUTING_NEW_GROUP = 'logger-app/groupManagement/TOGGLE_INPUTING_NEW_GROUP';
var CREATE_NEW_GROUP = 'logger-app/groupManagement/CREATE_NEW_GROUP';
var CREATE_NEW_GROUP_SUCCESS = 'logger-app/groupManagement/CREATE_NEW_GROUP_SUCCESS';

var initialState = {
  inputingNewGroup: false,
  savingNewGroup: false,
  errorSavingNewGroup: false,
  newGroupName: ''
};

function reducer() {
  var state = arguments.length <= 0 || arguments[0] === undefined ? initialState : arguments[0];
  var action = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  switch (action.type) {
    case SET_NEW_GROUP_NAME:
      return (0, _extends3.default)({}, state, {
        newGroupName: action.newGroupName,
        errorSavingNewGroup: false
      });
    case TOGGLE_INPUTING_NEW_GROUP:
      return (0, _extends3.default)({}, state, {
        inputingNewGroup: !state.inputingNewGroup
      });
    case CREATE_NEW_GROUP:
      return (0, _extends3.default)({}, state, {
        savingNewGroup: true
      });
    case CREATE_NEW_GROUP_SUCCESS:
      return (0, _extends3.default)({}, state, {
        inputingNewGroup: false,
        savingNewGroup: false,
        newGroupName: ''
      });
    case _sharedActions.CREATE_NEW_GROUP_FAIL:
      return (0, _extends3.default)({}, state, {
        savingNewGroup: false,
        errorSavingNewGroup: true
      });
    default:
      return state;
  }
}

function setNewGroupName(newGroupName) {
  return {
    type: SET_NEW_GROUP_NAME,
    newGroupName: newGroupName
  };
}

function toggleInputingNewGroup() {
  return {
    type: TOGGLE_INPUTING_NEW_GROUP
  };
}

function createNewGroup(newGroupName) {
  return {
    types: [CREATE_NEW_GROUP, CREATE_NEW_GROUP_SUCCESS, _sharedActions.CREATE_NEW_GROUP_FAIL],
    promise: function promise(client) {
      return client.post('/system/createNewGroup', {
        data: {
          newGroupName: newGroupName
        }
      });
    },
    newGroupName: newGroupName
  };
}