'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.newGroupEmitted = newGroupEmitted;
exports.groupNameChangeEmitted = groupNameChangeEmitted;
exports.groupDeleteEmitted = groupDeleteEmitted;
exports.newLogEmitted = newLogEmitted;
exports.logNameChangeEmitted = logNameChangeEmitted;
exports.logGroupChangeEmitted = logGroupChangeEmitted;
exports.logFileChangeEmitted = logFileChangeEmitted;
exports.logPathChangeEmitted = logPathChangeEmitted;
exports.logDeleteEmitted = logDeleteEmitted;
exports.tailErrorEmitted = tailErrorEmitted;
// Socket events
var NEW_GROUP_EMITTED = exports.NEW_GROUP_EMITTED = 'logger-app/sharedActions/NEW_GROUP_EMITTED';
var GROUP_NAME_CHANGE_EMITTED = exports.GROUP_NAME_CHANGE_EMITTED = 'logger-app/sharedActions/GROUP_NAME_CHANGE_EMITTED';
var GROUP_DELETE_EMITTED = exports.GROUP_DELETE_EMITTED = 'logger-app/sharedActions/GROUP_DELETE_EMITTED';
var NEW_LOG_EMITTED = exports.NEW_LOG_EMITTED = 'logger-app/sharedActions/NEW_LOG_EMITTED';
var LOG_DELETE_EMITTED = exports.LOG_DELETE_EMITTED = 'logger-app/sharedActions/LOG_DELETE_EMITTED';
var LOG_NAME_CHANGE_EMITTED = exports.LOG_NAME_CHANGE_EMITTED = 'logger-app/sharedActions/LOG_NAME_CHANGE_EMITTED';
var LOG_GROUP_CHANGE_EMITTED = exports.LOG_GROUP_CHANGE_EMITTED = 'logger-app/sharedActions/LOG_GROUP_CHANGE_EMITTED';
var LOG_FILE_CHANGE_EMITTED = exports.LOG_FILE_CHANGE_EMITTED = 'logger-app/sharedActions/LOG_FILE_CHANGE_EMITTED';
var LOG_PATH_CHANGE_EMITTED = exports.LOG_PATH_CHANGE_EMITTED = 'logger-app/sharedActions/LOG_PATH_CHANGE_EMITTED';
var TAIL_ERROR_EMITTED = exports.TAIL_ERROR_EMITTED = 'logger-app/sharedActions/TAIL_ERROR_EMITTED';

// API events
// Group Management
var CREATE_NEW_GROUP_FAIL = exports.CREATE_NEW_GROUP_FAIL = 'logger-app/sharedActions/CREATE_NEW_GROUP_FAIL';
var SAVE_GROUP_NAME_FAIL = exports.SAVE_GROUP_NAME_FAIL = 'logger-app/sharedActions/SAVE_GROUP_NAME_FAIL';
var DELETE_GROUP_FAIL = exports.DELETE_GROUP_FAIL = 'logger-app/sharedActions/DELETE_GROUP_FAIL';
// Log Management
var CREATE_NEW_LOG_FAIL = exports.CREATE_NEW_LOG_FAIL = 'logger-app/sharedActions/CREATE_NEW_LOG_FAIL';
var SAVE_LOG_CHANGES_FAIL = exports.SAVE_LOG_CHANGES_FAIL = 'logger-app/sharedActions/SAVE_LOG_CHANGES_FAIL';
var DELETE_LOG_FAIL = exports.DELETE_LOG_FAIL = 'logger-app/sharedActions/DELETE_LOG_FAIL';
// App Management
var APP_MANAGMENT_SAVE_SUCCESS = exports.APP_MANAGMENT_SAVE_SUCCESS = 'logger-app/sharedActions/SAVE_SUCCESS';
var APP_MANAGMENT_SAVE_FAIL = exports.APP_MANAGMENT_SAVE_FAIL = 'logger-app/sharedActions/SAVE_FAIL';

function newGroupEmitted(newGroupId, newGroupName) {
  return {
    type: NEW_GROUP_EMITTED,
    newGroupId: newGroupId,
    newGroupName: newGroupName
  };
}

function groupNameChangeEmitted(groupId, newName, oldName) {
  return {
    type: GROUP_NAME_CHANGE_EMITTED,
    groupId: groupId,
    newName: newName,
    oldName: oldName
  };
}

function groupDeleteEmitted(groupId, logIds, groupName) {
  return {
    type: GROUP_DELETE_EMITTED,
    groupId: groupId,
    logIds: logIds,
    groupName: groupName
  };
}

function newLogEmitted(newLogId, logName, groupId, logFile, logPath, groupName) {
  return {
    type: NEW_LOG_EMITTED,
    newLogId: newLogId,
    logName: logName,
    groupId: groupId,
    logFile: logFile,
    logPath: logPath,
    groupName: groupName
  };
}

function logNameChangeEmitted(logId, newName, oldName) {
  return {
    type: LOG_NAME_CHANGE_EMITTED,
    logId: logId,
    newName: newName,
    oldName: oldName
  };
}

function logGroupChangeEmitted(logId, logName, newGroupName, oldGroupName, newGroupId, oldGroupId) {
  return {
    type: LOG_GROUP_CHANGE_EMITTED,
    logId: logId,
    logName: logName,
    newGroupName: newGroupName,
    oldGroupName: oldGroupName,
    newGroupId: newGroupId,
    oldGroupId: oldGroupId
  };
}

function logFileChangeEmitted(logId, logName, newFile, oldFile) {
  return {
    type: LOG_FILE_CHANGE_EMITTED,
    logId: logId,
    logName: logName,
    newFile: newFile,
    oldFile: oldFile
  };
}

function logPathChangeEmitted(logId, logName, newPath, oldPath) {
  return {
    type: LOG_PATH_CHANGE_EMITTED,
    logId: logId,
    logName: logName,
    newPath: newPath,
    oldPath: oldPath
  };
}

function logDeleteEmitted(groupId, logId, logName, groupName) {
  return {
    type: LOG_DELETE_EMITTED,
    groupId: groupId,
    logId: logId,
    logName: logName,
    groupName: groupName
  };
}

function tailErrorEmitted(logId, errorReason, errorCode) {
  return {
    type: TAIL_ERROR_EMITTED,
    logId: logId,
    errorReason: errorReason,
    errorCode: errorCode
  };
}